#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: admacl_edit.cgi,v 1.2 2005/06/23 15:32:12 ynakam Exp $

# Display access rights for administration

use Fcntl;
use CGI qw(:standard);
do "./common.pl";

#ACL for administration
#key:the argument of allowadm
#value:1
local %Global_adm_acl;
local %adm_acl;

$Jscript =<<"EOL";
function check_changed(msg) {
    if (parent.config.document.edit_form.elements["changed"].value == 1)
    {
	alert(msg);
    }
}

function set_change() {
    parent.config.document.edit_form.elements["changed"].value = 1;
}

function unset_change() {
    parent.config.document.edit_form.elements["changed"].value = 0;
}
EOL

local $Policy_root = set_policy_root();

local $domain;
$domain = param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html></html>";
    return;
}

&read_adm_acl($domain, \%adm_acl);
if ($domain ne "global")
{
    &read_adm_acl("global", \%Global_adm_acl);
}

&print_editor();

sub print_editor() {
    &print_header();
    my $notchange = $text{"notchanged"};
    print start_html(-title=>$text{"admin_acl"},-onUnload=>"check_changed(\'$notchange\')");
    print "<SCRIPT language=\"Javascript\">";
    print $Jscript;
    print "</SCRIPT>";

    print h2(&text("adm_title", $domain)), p;
    print start_form(-method=>"post",-action=>"setadmacl.cgi",-name=>"edit_form");
    print hidden(-name=>"domain",-value=>"$domain");
    print hidden(-name=>"changed",-value=>"0");


#  foreach (keys %adm_acl){
#   print "$_".";"."$adm_acl{$_}",p;
# }

    &print_check_box("relabel", $text{"adm_relabel"});
    &print_check_box("part_relabel", $text{"adm_part_relabel"});
    &print_check_box("getsecurity", $text{"adm_getsecurity"});
    &print_check_box("setenforce", $text{"adm_setenforce"});
    &print_check_box("load_policy", $text{"adm_load_policy"});
    &print_check_box("net", $text{"adm_net"});
    &print_check_box("boot", $text{"adm_boot"});
    &print_check_box("insmod", $text{"adm_insmod"});
    &print_check_box("quotaon", $text{"adm_quota"});
    &print_check_box("swapon", $text{"adm_swap"});
    &print_check_box("mount", $text{"adm_mount"});
    &print_check_box("raw_io", $text{"adm_raw_io"});
    &print_check_box("ptrace", $text{"adm_ptrace"});
    &print_check_box("chroot", $text{"adm_chroot"});
    &print_check_box("search", $text{"adm_search"});
    &print_check_box("read", $text{"adm_read"});
    &print_check_box("write", $text{"adm_write"});
    &print_check_box("unlabel", $text{"adm_unlabel"});
    &print_check_box("all", $text{"adm_all"});
    
    print submit(-value=>$text{"apply"},-onClick=>"unset_change()");
    print end_form();
    print end_html();
}

sub print_check_box($$) {
    my $name;
    my $label;
    ($name,$label) = @_;

    if ($Global_adm_acl{$name} == 1)
    {
	print "ok $label",p;
    }
    else
    {
	my $checked;
	$checked = $adm_acl{$name};
	print checkbox(-name=>$name,-value=>"on",-label=>$label,-checked=>$checked,-onChange=>"set_change()"),p;
    }
}


sub read_adm_acl() {
    my $domain;
    my $hash_ref;
    my $filename;

    ($domain,$hash_ref) = @_;

    if ($domain eq "global")
    {
	$filename = $Policy_root."/global";
    }
    else
    {
	$filename = $Policy_root."/$domain".".a";
    }

    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	# Skip spaces in the head of line 
	if (/[^\s\t]+.+/)
	{
	    $_ = $&;
	}
	if (/^allowadm[\s\t]/)
	{
	    my @tmp;
	    @tmp = split(/[\s\t]+/,$_);
	    my $str;
	    $str = $tmp[1];
	    if ($str =~ /;/)
	    {
		chop($str);
	    }
	    my @perms;
	    @perms = split(/,/, $str);
	    foreach (@perms)
	    {
		$$hash_ref{$_} = 1;
	    }
	}
    }

    close(FILE);
}
