#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: common.pl,v 1.2 2005/06/22 15:35:52 ynakam Exp $

#######global value############
#Definition of static value
$DENY=0;
$READ=2;
$WRITE=4;
$APPEND=8;
$EXECUTE=16;
$SEARCH=128;
$EXC_CREATE=32;#permission to create "exclusive file"
$DENY_EXPLICIT=64;#explicitly deny


# These are common functions for this tool.
use Fcntl;
do '../web-lib.pl';
&init_config();


#Print CGI header according to language configuration of Webmin.
#!!Attention!!
#If the versionup of Webmin occurs,you may be unable to use
#$current_lang_info$force_charset
sub print_header() {
    my $charset = defined($force_charset) ? $force_charset :
	$current_lang_info->{'charset'} ?
	$current_lang_info->{'charset'} : "iso-8859-1";

    print "Content-type: text/html; Charset=$charset\n\n";
}


# reads the file assosiated with $domain,and returns comment
sub read_comment($$) {
    my $domain;
    my $root;
    my $filename;
    my $comment;

    ($domain,$root)=@_;

    if ($domain eq "global")
    {
	$filename = $root."/global";
    }
    else
    {
	$filename = $root."/$domain".".a";
    }

    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	if (/#comment:/)
	    {
		$_=~s/#comment://;
		$comment=$_;
		last;
	    }
	}

	close(FILE);
	return $comment;
}


#returns the path of configuration files written in middle language.
sub set_policy_root() {
    my $root_dir;
    $root_dir = $config{"policy_root"}; 
    return $root_dir;
}


#Argument:1,reference to hash 2,path to configuration files.
#sets key:domain name, value:1(if arg 2 is domain),2(role) in hash(arg 1).
sub read_domain_list($$) {
    my $ref;
    my $path;
    my $filename;
    ($ref,$path)=@_;

    opendir(DIR,$path) or die  "could not open $path";

    while ($_=readdir(DIR))
    {
	if (/\.a$/)
	{
	    $filename=$path."/".$_;
	}
	elsif ($_ eq "global")
	{
	    $filename=$path."/".$_;
	}
	else
	{
	    next;
	}

	#pick up domain names from configuration files
	sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

	while (<FILE>)
	{
	    my @s;
	    #skip spaces in the head of line.
	    if (/[^\s\t]+.+/)
	    {
		$_=$&;
	    }
	    #skip comments
	    if ( /[\s\t]+\#/ || /^\#/)
	    {
		next;
	    }

	    if (/domain[\s\t]/)
	    {
		my $domain;
		@s=split(/[\s\t]+/,$_);
		$domain=$s[1];
		#strip ';' at the end of line.
		if ($domain=~/;/)
		{
		    chop($domain);
		}
		$$ref{$domain}=1;
		last;
	    }

	    if (/role[\s\t]/)
	    {
		my $role;
		@s=split(/[\s\t]+/,$_);
		$role=$s[1];
		#strip ';' at the end of line.
		if ($role=~/;/)
		{
		    chop($role);
		}
		$$ref{$role}=2;
		last;
	    }
	}
	close(FILE);
    }
    close(DIR);
}



sub read_file_skip($$$){
  my $filename;
  my $buf_ref;
  my $skip_ref;

  ($filename,$buf_ref,$skip_ref)=@_;

  sysopen(SFILE,"$filename",O_RDONLY) or die "File open error:$filename\n";
    while (<SFILE>)
    {
	my $line=$_;
	#skip spaces
	if ($line=~/[^\s\t]+.+/)
	{
	    $line=$&;
	}
	if ($line=~/}/||$line=~/{/)
	{
	    next;
	}
	if ($line eq "\n")
	{
	    next;
	}

	my $flag=0;
	foreach (@$skip_ref)
	{
	    if ($line=~/$_/)
	    {
		$flag=1;
	    }
	}
	if ($flag == 1)
	{
	    #  print $line,br;
	    next;
	}
	push @$buf_ref,$_;
    }

    close(SFILE);
}


sub get_domain_filename($$){
  my $domain;
  my $root;
  my $filename;
  ($domain,$root)=@_;

  if ($domain eq "global")
    {
      $filename = $root."/global";
    }
    else
    {
      $filename=$root."/$domain".".a";
    }
  return $filename;
}


sub read_file_in_buf($$){
  my $filename;
  my $buf_ref;
  ($filename,$buf_ref)=@_;
  
  sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

  while(<FILE>){
    push @$buf_ref,$_;
  }

  close(FILE);
}


#read file associated with $domain,and skip the lines which match pattern in $skip_ref,and save lines in $buf_ref
sub read_conf_file_skip($$$$) {
    my $domain;#domain name
	my $root;#the path to config files.
	my $buf_ref;#buffer for lines.
	my $skip_ref;#reference to the array where patterns to skip is stored.
	my $filename;
    ($domain,$root,$buf_ref,$skip_ref)=@_;

    if ($domain eq "global")
    {
	$filename = $root."/global";
    }
    else
    {
	$filename=$root."/$domain".".a";
    }
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	my $line=$_;
	#skip spaces
	if ($line=~/[^\s\t]+.+/)
	{
	    $line=$&;
	}
	if ($line=~/}/||$line=~/{/)
	{
	    next;
	}
	if ($line eq "\n")
	{
	    next;
	}

	my $flag=0;
	foreach (@$skip_ref)
	{
	    if ($line=~/$_/)
	    {
		$flag=1;
	    }
	}
	if ($flag == 1)
	{
	    #  print $line,br;
	    next;
	}
	push @$buf_ref,$_;
    }

    close(FILE);
}

#encodes argument in URL format and return
sub url_encode($) {
    my $str=$_[0];
    $str=~ s/([^\.\*\-_a-zA-Z0-9 ])/sprintf("%%%02lX",unpack("C",$1))/eg;
    $str =~ s/ /+/g;

    return $str;
}

#strip "_t","_r" from domain/role name.
sub get_prefix($) {
    my $str=$_[0];

    if ($str=~/_t$/)
    {
	$str=~s/_t$//;
    }
    elsif($str=~/_r$/)
    {
	$str=~s/_r$//;
    }

    return $str;
}

#return domain name lists related to $prog
sub get_prog_domains($$) {
    my $path;
    my $prog;
    my $filename;
    my @prog_domains;

    ($path,$prog)=@_;

    opendir(DIR,$path) or die  "could not open $path";

    while ($_=readdir(DIR))
    {
	if (/\.a$/)
	{
	    $filename=$path."/".$_;
	}
	elsif($_ eq "global")
	{
	    $filename=$path."/".$_;
	}
	else
	{
	    next;
	}

	sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";
	my $domain;
	while (<FILE>)
	{
	    my @s;
	    #skip spaces in the head of line.
	    if (/[^\s\t]+.+/)
	    {
		$_=$&;
	    }
	    #skip comments
	    if (/[\s\t]+\#/ || /^\#/)
	    {
		next;
	    }

	    if (/domain[\s\t]/)
	    {
		@s=split(/[\s\t]+/,$_);
		$domain=$s[1];
		#strip ';' at the end of line.
		if ($domain=~/;/)
		{
		    chop($domain);
		}
		next;
	    }

	    if (/domain_trans.*$prog/)
	    {
		push @prog_domains,$domain;
	    }
	}
    }
    close(DIR);

    return @prog_domains;
}


#read $filename and set sentence $buf_ref
#"Sentence" is splited by ";"
sub read_in_buf($$) {
    my $filename;
    my $buf_ref;
    ($filename,$buf_ref)=@_;

    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";
    while (<FILE>)
    {
	my $line=$_;
	if ($line=~/;/)
	{
	    my @str;
	    @str=split(/;/,$line);
	    foreach (@str)
	    {
		push @$buf_ref,$_;
	    }
	}
	else
	{
	    push @$buf_ref,$line;
	}
    }

    close(FILE);
}




sub write_buf($$$$) {
    my $domain;
    my $root;
    my $buf_ref;
    my $flag;
    ($domain,$root,$buf_ref,$flag)=@_;

    my $filename;
    if ($domain eq "global")
    {
	$filename=$root."/".$domain;
    }
    else
    {
	$filename=$root."/".$domain.".a";
    }
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC|O_CREAT) or die "File open error:$filename\n";

    if($flag!=1){
      print FILE "{\n";
    }
    foreach (@$buf_ref)
    {
      if($_ eq "\n"){
	;
      }else{
	print FILE "$_\n";
      }
    }
    if($flag!=1){
      print FILE "}\n";
    }

    close(FILE);
}

sub escape_tag($) {
    my $str=$_[0];

    $str=~s/&/&amp/;
    $str=~s/</&lt/;
    $str=~s/>/&gt/;
    $str=~s/\"/&quot/;
    $str=~s/\'/&#39/;

    return $str;
}


#this checks invalid domain in @$ref by using %$domain_hashref.
#if error,exits.
sub chk_params($$) {
    my $ref;
    my $domain_hashref;
    ($ref,$domain_hashref)=@_;

    foreach (@$ref)
    {
	my $element=$_;
	@tmp=split(/[\s\t]+/,$element);

	foreach (@tmp)
	{
	    if ($_=~/\S/ && !exists($$domain_hashref{$_}))
	    {
		my $name=$_;
		$name=&escape_tag($name);
		&print_header();
		start_html();
		print  &text("trans_domain_not_exist",$name);
		end_html();
		exit;
	    }
	}
    }
}


sub write_default_type($$) {
    my $root;
    my $domain_list;

    ($root,$domain_list)=@_;

    #write default_type
    $filename=$root."/default_type";
    #open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    my $key;
    foreach $key(keys(%$domain_list))
    {
	#when role
	if ($$domain_list{$key} == 2)
	{
	    my $role;
	    my $prefix;
	    $role=$key;
	    $prefix=get_prefix($role);
	    print FILE "$role:$prefix"."_t\n";
	}
    }
    close(FILE);
}



sub get_template_file_list($$){
  my $list;
  my $path;
  ($list,$path)=@_;
  opendir(DIR,$template_path) or die  "could not open $template_path";
  while($_=readdir(DIR)){
    if(/\.tem$/){
      push @$list,$_;
    }else{
      next;
    }
  }
}

sub get_template_list($$){
  my $list;
  my $path;
  ($list,$path)=@_;
  opendir(DIR,$template_path) or die  "could not open $template_path";
  while($_=readdir(DIR)){
    if(/\.tem$/){
      $_=~s/\.tem$/_template/;
      push @$list,$_;
    }else{
      next;
    }
  }
}


#Checks whether there is a pattern which matches $pattern in $filename
sub check_match($$){
  my $filename;
  my $pattern;
  ($filename,$pattern)=@_;

  sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

  while (<FILE>){
    if($_=~/$pattern/){
      close(FILE);
      return 1;
    }
  }

  close(FILE);
  return 0;
}


#make %allow_hash(files described by allow or deny) key:filename value:permission
#and %allow_only_hash(files described by allowonly or denyonly) key:filename value:permisson
#and %explicit_hash(files explicitly configured) key:filename value:1
sub parse_allow_one_line($$$$){
  my $line;
  my $allow_hash;
  my $allow_only_hash;
  my $explicit_hash;
  ($line,$allow_hash,$allow_only_hash,$explicit_hash)=@_;

  my $path;
  my $permstr;
  my $perm;
  my $tmp;

  $_=$line;

  #skip spaces
  if (/[^\s\t]+.+/) {
    $_=$&;
  }
  #skip comments
  if ( /[\s\t]+\#/||/^\#/) {
    return;
  }
  #skip allowexclusive
  if (/[\s\t]exclusive[\s\t]/) {
    return;
  }
  if (/^role[\s\t]/) {
    return;
  }
  ###analyze allow,allowonly,deny,denyonly
  if ( /^allow[\s\t]+/ ) {
    /\/\S*/;
    $path=$&;
    if ($path!~/\//) {	
      #allow exclusive
      return;
    }
    chop_slash($path);
    /[r,w,x,a,s]+[\s\t]*;/ ;
    $permstr=$&;
    $perm=str_to_perm($permstr);
    $tmp=$$allow_hash{$path};
    if ($tmp ne "") {
      $tmp|=$perm;
      $$allow_hash{$path}=$tmp;
      $$explicit_hash{$path}=1;
    } else {
      $$allow_hash{$path}=$perm;
      $$explicit_hash{$path}=1;
    }
  } elsif ( /^deny[\s\t]+/ ) {
    /\/[^(;\t\s)]*/;
    $path=$&;
    if ($path!~/\//) {
      return;
    }
    chop_slash($path);
    #   print "$path\n";
    $$allow_hash{$path}=$DENY;
    $$explicit_hash{$path}=1;
  } elsif (/[\s\t]*denyonly[\s\t]+/) {
    /\/[^(;\t\s)]*/;
    $path=$&;
    chop_slash($path);
    $$allowonly_hash{$path}=$DENY;;
    $$explicit_hash{$path}=1;
  } elsif ( /^allowonly[\s\t]+/ ) {
    /\/\S*/;
    $path=$&;
    if ($path!~/\//) {
      return;
    }
    chop_slash($path);
    /[r,w,x,a,s]+[\s\t]*;/ ;
    $permstr=$&;
    $perm=str_to_perm($permstr);

    $tmp=$$allowonly_hash{$path};
    if ($tmp ne "") {
      $tmp|=$perm;
      $$allowonly_hash{$path}=$tmp;
      $$explicit_hash{$path}=1;
    } else {
      $$allowonly_hash{$path}=$perm;
      $$explicit_hash{$path}=1;
    }
  } elsif ( /^denyonly[\s\t]+/ ) {
    /\/[^(;\t\s)]*/;
    $path=$&;
    chop_slash($path);
    $$allowonly_hash{$path}=$DENY;
  } else {
    #
    if ( /{/||/}/ ||/domain/) {
      ;
    } else {
      if (/\w/) {
	;
      }
    }
  }


}


#make %allow_hash key:filename value:permission
#and %allow_only_hash key:filename value:permisson
#from @buf
sub make_file_allow_hash($$$){
  my $allow_hash;
  my $allow_only_hash;
  my $buf_ref;
  ($allow_hash,$allowonly_hash,$buf_ref)=@_;

  my %dummy_hash;
  foreach (@$buf_ref){
    &parse_allow_one_line($_,$allow_hash,$allowonly_hash,\%dummy_hash);
  }
}


#chop_slash(str)
#strip "/" at the end of str.
sub chop_slash($) {
    if ($_[0] eq "/")
    {
	return;
    }

    if ($_[0]=~/.*\/$/)
    {
	chop($_[0]);
    }
}

#str_to_perm(str)
#return permission related to str.
sub str_to_perm($) {
    my $perm;
    $_=$_[0];
    $perm=$DENY;
    if (/r/)
    {
	$perm|=$READ;
    }
    if (/w/)
    {
	$perm|=$WRITE;
    }
    if (/x/)
    {
	$perm|=$EXECUTE;
    }
    if (/s/)
    {
	$perm|=$SEARCH;
    }

    return $perm;
}

sub perm_to_str($) {
    my $perm=$_[0];
    my $str="";

    if ($perm == $DENY)
    {
	$str = "DENY";
    }

    if ($perm & $READ)
    {
	$str .= "r,";
    }

    if ($perm & $WRITE)
    {
	$str .= "w,";
    }

    if ($perm & $EXECUTE)
    {
	$str .= "x,";
    }

    if ($perm & $EXC_CREATE)
    {
	$str .= "c,";
    }

    if ($perm & $SEARCH)
    {
	$str .= "s,";
    }

    if ($str =~ /,/)
    {
	chop($str);
    }

    return $str;
}

#construct sentences into @$buf_ref from hashes
#(allow_hash->key:file,value:permission ,allowonly_hash->key:file,value:permission)
sub convert_allow_hash_to_sentence($$$){
  my $allow_hash_ref;
  my $allowonly_hash_ref;
  my $buf_ref;
  ($allow_hash_ref,$allowonly_hash_ref,$buf_ref)=@_;

  foreach (keys(%$allow_hash_ref)){
    my $str;
    my $file=$_;
    if($$allow_hash_ref{$_}==$DENY){
      $str="deny $file;\n";
    }else{
      my $perm=&perm_to_str($$allow_hash_ref{$_});
      $str="allow $file $perm;\n";
    }
    push @$buf_ref,$str;
  }
  foreach (keys(%$allowonly_hash_ref)){
    my $str;
    my $file=$_;
    if($$allowonly_hash_ref{$_}==$DENY){
      $str="denyonly $file;\n";
    }else{
      my $perm=&perm_to_str($$allowonly_hash_ref{$_});
      $str="allowonly $file $perm;\n";
    }
    push @$buf_ref,$str;
  }

}


#return filename from $fullpath
sub get_filename_from_fullpath($){
  my $fullpath;
  my $filename;
  $fullpath=$_[0];
  $fullpath=~/\/([^\/]*)$/;
  $filename=$&;
  $filename=~s/\///;
  return $filename;
}

#return directory which $fullpath belongs to
sub get_belonging_dir($){
  my $fullpath=$_[0];
  my $parent;
  $parent=$fullpath;
  $parent=~s/\/([^\/]*)$//;
  if($parent eq ""){
    $parent="/";
  }
  return $parent;
}


1;
