#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: edit_exclusive.cgi,v 1.1.1.1 2005/05/25 16:47:04 ynakam Exp $

use Fcntl;
use FileHandle;
use CGI qw(:standard);
require './common.pl';
require './selinux-lib.pl';
local $query;
local @elements;
local $element;
local $exclusive_name;
local $current_domain;
my $outfile;
my $fh;

#print "Content-type: text/html\n\n";

read(STDIN,$query,$ENV{'CONTENT_LENGTH'});

&parse_query();

if ($exclusive_name=~/[^a-zA-Z_0-9]/)
{
    &print_header();
    start_html();
    print $text{"exc_error"};
    end_html();

    exit;
}



#store configuration not related to allow exclusive.
local @buffer;
local @skip;
push @skip,"^allow[\\s\\t]";
push @skip,"^allowonly[\\s\\t]";
push @skip,"^deny[\\s\\t]";
push @skip,"^denyonly[\\s\\t]";
&read_conf_file_skip($current_domain,$Policy_root,\@buffer,\@skip);

&read_domain_file_acl($current_domain);
&read_exc_file_acl($current_domain);


#You can't name resourse the name already registared.
foreach $key (keys %Exc_dir)
{
    if ($Exc_dir{$key}=~/$exclusive_name/)
    {
	redirect("miniwindow.cgi?filepath=".$current_dir."&domain=".$current_domain."&status=error1&comment=$key");

	exit;
    }
}

if (exists($Exc_dir{$current_dir}))
{
    $Exc_dir{$current_dir}.=",".$exclusive_name;
}
else
{
    $Exc_dir{$current_dir}.=$exclusive_name;
}
$Exc_allow{$exclusive_name}=$EXC_CREATE;

#you can't use "allow exclusive" for the same domain and directory.
my @tmp=split(/,/,$Exc_dir{$current_dir});
my $i=0;


foreach (@tmp)
{
    if ($Exc_allow{$_} == $EXC_CREATE)
    {
	$i++;
    }
}

if ($i>1)
{
    redirect("miniwindow.cgi?filepath=".$current_dir."&domain=".$current_domain."&status=error2");

    exit;
}


$fh =FileHandle->new();
$outfile=$Policy_root."/".$current_domain.".a";

#open($fh,">$outfile") or die "no $outfile\n";
sysopen($fh,"$outfile",O_WRONLY|O_TRUNC| O_CREAT) or die "no $outfile\n";


print $fh "{\n";
foreach (@buffer)
{
    print $fh "$_\n";
}
&print_domain_set_file($fh,$current_domain,$current_dir);
print $fh "}\n";

redirect("miniwindow.cgi?filepath=".$current_dir."&domain=".$current_domain."&status=ok");


sub parse_query() {
    @elements=split(/&/,$query);

    for $element (@elements)
    {
	($key,$value)=split(/=/,$element);
	$key=~s/%([\dA-Fa-f]{2})/pack("C",hex($1))/ge;
	$value=~s/%([\dA-Fa-f]{2})/pack("C",hex($1))/ge;

	if ($key eq "name")
	{
	    $exclusive_name=$value;
	    next;
	}
	if ($key eq "domain")
	{
	    $current_domain=$value;
	    next;
	}
	if ($key eq "dir")
	{
	    $current_dir=$value;
	    next;
	}
    }
}
