#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: file2_perm.cgi,v 1.1.1.1 2005/05/25 16:47:06 ynakam Exp $

#display domain name list which can access a file/directory

use CGI qw(:standard);
require './selinux-lib.pl';

#directory where a file/directory belongs
local $current_dir;
#permission of $current_dir
local $default_perm;

local %Domainlist;
&read_domain_list(\%Domainlist,$Policy_root);
local $filename=param("filename");
my $action_flag=param("switch");

local $relabel_flag=0;


&print_header();
print start_html();

print &text("exc_perm_title",$filename),p;

if($action_flag ne "all"){
  print start_form(-method=>"post",-action=>"file2_perm.cgi",-name=>"select_form");
  print hidden(-name=>"filename",-value=>$filename);
  print hidden(-name=>"switch",-value=>"all");
  print submit(-value=>$text{"show_all_domain"});
  print end_form();
}


print start_form(-method=>"post",-action=>"set_file2_perm.cgi",-name=>"edit_form");
print hidden(-name=>"filename",-value=>$filename);


local @table;

my $first_row_ref;
$first_row_ref=["domain","r","w","x","s"];
$first_row_ref2=[$text{"inherit_child"}," "];

if(-d $filename){
  push @table,th({-bgcolor=>"yellow"},$first_row_ref).th({-colspan=>"2",-bgcolor=>"yellow",-align=>"center"},$first_row_ref2);
}else{
  push @table,th({-bgcolor=>"yellow"},$first_row_ref);
}

my $current_domain;
my @list=keys( %Domainlist);
@list=sort(@list);

foreach $current_domain (@list) {
    my @row;
    if ($current_domain ne "global")
    {
	undef(%Domain_allow);
	undef(%Domain_allowonly);
	undef(%Exc_allow);
	&read_domain_file_acl($current_domain);
	&read_exc_file_acl($current_domain);
    }
    my $perm;
    my $permstr;
 
    $perm=&calc_perm($filename,$current_domain);
    $permstr=&perm_to_str($perm);

    local $search_flag;
    local $read_all_flag;
    local $write_all_flag;

    $search_flag=&check_search_all($current_domain,$Policy_root);
    $read_all_flag=&check_adm($current_domain,$Policy_root,"read");
    $write_all_flag=&check_adm($current_domain,$Policy_root,"write");


    if ($action_flag eq "all"||	$permstr ne "DENY" || 
	$search_flag==1||$read_all_flag==1||$write_all_flag==1){
      push @row,"$current_domain";

      &push_cell(\@row,$current_domain,$permstr,$read_all_flag,"r");
      &push_cell(\@row,$current_domain,$permstr,$write_all_flag,"w");
      my $dummy_flag=0;
      &push_cell(\@row,$current_domain,$permstr,$dummy_flag,"x");
      &push_cell(\@row,$current_domain,$permstr,$search_flag,"s");
      if(-d $filename){
	&push_radio_button(\@row,$current_domain,$filename);
      }
      push @table,td(\@row);

    }

  }

#@table=sort(@table);
print table(Tr(\@table));
print hr;
print submit(-value=>$text{"apply"});
print end_form();
print end_html();

sub push_cell($$$){
  my $row_ref;
  my $domain;
  my $permstr;
  my $all_flag;
  my $pattern;
  ($row_ref,$domain,$permstr,$all_flag,$pattern)=@_;
  my $flag;


  if ($permstr=~/$pattern/){
    $flag=1;
  }else{
    $flag=0;
  }

  my $name;
  $name="$pattern"."_"."$domain";

  if($all_flag==1){

    if($flag==1){

      push @$row_ref,$text{"ok"}.hidden(-name=>"$name",-value=>"on");
    }else{
      push @$row_ref,$text{"ok"};
    }

  }else{
    push @$row_ref,checkbox(-name=>"$name",-value=>"on",-label=>"",-checked=>$flag);
  }

}


sub push_radio_button($$$){
   my $row_ref;
   my $domain;
   my $filename;
   ($row_ref,$domain,$filename)=@_;

   my $onlyflag=&get_only_flag($filename);
   print hidden(-name=>"name_$domain",-value=>"1");

   if($onlyflag==0){
     push @$row_ref,radio_group(-name=>"radio_$domain",-values=>["all","only"],-labels=>{"all"=>"yes","only"=>"no"},-default=>"all",-onChange=>"set_change()");
   }else{
     #allowonly
     push @$row_ref,radio_group(-name=>"radio_$domain",-values=>["all","only"],-labels=>{"all"=>"yes","only"=>"no"},-default=>"only",-onChange=>"set_change()");
   }

}


