#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: ipcacl_edit.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

#Display IPC ACL configuration 
use Fcntl;
use CGI qw(:standard);
require 'common.pl';

local $Policy_root=set_policy_root();

local $domain;
$domain=param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html></html>";

  return;
}

#key:the kind of IPC
#value:domain names which the domain can communicate via IPC,separated by space
local %IPC_acl;

#IPC ACL for global domain
#key:the kind of IPC
#value:domain names which the domain can communicate via IPC,separated by space
local %Global_IPC_acl;

&read_ipc_acl($domain,\%IPC_acl);
if ($domain ne "global")
{
    &read_ipc_acl("global",\%Global_IPC_acl);
}

#All domain names are stored.
local %Domain_list;
&read_domain_list(\%Domain_list,$Policy_root);

&print_table();

sub read_ipc_acl($$) {
    my $domain;
    my $hash_ref;
    my $filename;
    ($domain,$hash_ref)=@_;

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n;";

    while (<FILE>)
    {
	#skip spaces in the head of line.
	if (/[^\s\t]+.+/)
	{
	    $_=$&;
	}

	if (/^allowcom[;\s\t]/)
	{
	    my @tmp;
	    my $opt;
	    my $to_domain;
	    @tmp= split(/[\s\t]+/,$_);
	    $opt=$tmp[1];
	    $to_domain=$tmp[2];
	    if ($to_domain=~/;/)
	    {
		chop($to_domain);
	    }

	    if ($opt ne "-sig")
	    {
		$$hash_ref{$opt}.=" $to_domain";
	    }
	    else
	    {				#allowcom -sig , process option [c],[k],[s],[o]
		my @perm;
		@perm=split(/,/,$tmp[3]);
		foreach (@perm)
		{
		    if (/;/)
		    {
			chop($_);
		    }
		    $$hash_ref{$_}.=" $to_domain";
		}
	    }
	}
    }

    close(FILE);
}



sub print_table() {
    &print_header();
    my $notchange=$text{"notchanged"};
    print start_html(-lang=>'japanese',-title=>$text{"ipc_acl"},-onUnload=>"check_changed(\'$notchange\')");
    print "<SCRIPT language=\"JavaScript\" src=\"ipcacl_edit.js\"></SCRIPT>\n";
    print h2(&text("ipc_title",$domain));

    print start_form(-method=>"post",-action=>"setipcacl.cgi",-name=>"edit_form");

    print hidden(-name=>"domain",-value=>"$domain");
    print hidden(-name=>"changed",-value=>"0");


    my @table;
    print table({-border=>0});
    push @table,td({-colspan=>"4",-align=>"center",-bgcolor=>"yellow"},[$text{"ipc_socket"}]);
    push @table,td(["",$text{"self"},$text{"all"},$text{"allowed_domain"}]);
    &make_field("-tcp",$text{"tcp_socket"},\@table);
    &make_field("-udp",$text{"udp_socket"},\@table);
    &make_field("-unix",$text{"unix_socket"},\@table);


    push @table,td({-colspan=>"4",-align=>"center",-bgcolor=>"yellow"},["IPC"]);

    push @table,td(["",$text{"self"},$text{"all"},$text{"allowed_domain"}]);
    &make_field("-sem",$text{"ipc_sem"},\@table);
    &make_field("-msg",$text{"ipc_msg"},\@table);
    &make_field("-msgq",$text{"ipc_msgq"},\@table);
    &make_field("-shm",$text{"ipc_shm"},\@table);
    &make_field("-pipe",$text{"ipc_pipe"},\@table);

    push @table,td({-colspan=>"4",-align=>"center",-bgcolor=>"yellow"},[$text{"ipc_sig"}]);

    push @table,td(["",$text{"self"},$text{"all"},$text{"allowed_domain"}]);
    &make_field("c","sigchld",\@table);
    &make_field("k","sigkill",\@table);
    &make_field("s","sigstop",\@table);
    &make_field("o",$text{"other"},\@table);


    push @table,td([submit(-value=>$text{"apply"},-onClick=>"unset_change()")]);


    print table(Tr(\@table));
    print end_form();
    print end_html();
}


#construct row 
sub make_field($$$) {
    my $key;
    my $menustr;
    my $table_ref;
    ($key,$menustr,$table_ref)=@_;

    my @domain_list;
    my $check1=0;
    my $check2=0;
    my $domain_str;

    @domain_list=split(/\s/,$IPC_acl{$key});
    foreach (@domain_list)
    {
	if ($_ eq "self")
	{
	    $check1=1;
	}
	elsif($_ eq "global")
	{
	    $check2=1;
	}
	else
	{
	    $domain_str.=" $_";
	}
    }

    my @global_list;
    my $global_check1=0;
    my $global_check2=0;
    my $global_domain_str="";
    @global_list=split(/\s/,$Global_IPC_acl{$key});
    #print @global_list;
    foreach(@global_list)
    {
	#print ";$_;";
	if($_ eq "self"){
	    $global_check1=1;
	}
	elsif ($_ eq "global")
	{
	    $global_check2=1;
	}
	else
	{
	    $global_domain_str.=" $_";
	}
    }

    my $cb1str;
    my $cb2str;
    my $textstr;
    my $selectstr;
    #print $global_check1;
    if ($global_check1==1)
    {
	$cb1str=$text{"ok"};
    }
    else
    {
	$cb1str=checkbox(-name=>"$key"."_self",-value=>"on",label=>"",-checked=>$check1,-onChange=>"set_change()");
    }
    if ($global_check2==1)
    {
	$cb2str=$text{"ok"};
    }
    else
    {
	$cb2str=checkbox(-name=>"$key"."_all",label=>"",-value=>"on",-checked=>$check2,-onChange=>"set_change()");
    }
    $textstr=$global_domain_str.textfield(-name=>"$key"."_text",-value=>$domain_str,-onChange=>"set_change()");

    delete $Domain_list{$domain};
    delete $Domain_list{"global"};
    my  @domain_array=keys %Domain_list;
    @domain_array=sort @domain_array;
    unshift @domain_array,"";
    my %labelhash;
    foreach (@domain_array)
    {
	$labelhash{$_}=$_;
    }

    my $msg;
    $msg=$text{"add_text_box"};
    $selectstr=$text{"choose"}.scrolling_list(-name=>"$key"."_list",-values=>\@domain_array,-size=>1,-labels=>\%labelhash,-onChange=>"select_domain(\'$key\',\'$msg\')");

    push @$table_ref,td([$menustr,$cb1str,$cb2str,$textstr,$selectstr]);
}

