#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: netacl_edit.cgi,v 1.3 2005/06/23 15:32:12 ynakam Exp $
# Cleanup by Yuichi Nakamura
# Display network ACL
use Fcntl;
use CGI qw(:standard);
use Class::Struct; 

require "./common.pl";

#structure to store acl related to network
struct Netacl => {
    net => '$',
    connect => '$',
    netlink => '$',
    raw  => '$',
    welltcp => '$',
    welludp => '$',
    reserving_tcp => '@',
    reserving_udp => '@'
};

local $netacl =  Netacl->new(); 
local $global_netacl =  Netacl->new(); 

$Jscript =<<"EOL";
function check_changed(msg) {
    if (parent.config.document.edit_form.elements["changed"].value ==1)
    {
	alert(msg);
    }
}

function set_change() {
    parent.config.document.edit_form.elements["changed"].value=1;
}

function unset_change() {
    parent.config.document.edit_form.elements["changed"].value=0;
}
EOL



#port numbers reserved by other domains
local @Reserved_tcp;
local @Reserved_udp;

#&print_header();

local $Policy_root=set_policy_root();
local $domain;
$domain=param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html></html>";

  return;
}

&read_net_acl($domain);


if($domain ne "global")
{
    &read_net_acl_global();
}

&read_reserved_ports(\@Reserved_tcp,\@Reserved_udp,$Policy_root,$domain);

&print_header();
my $notchange=$text{"notchanged"};
print start_html(-title=>$text{"net_acl"},-onUnload=>"check_changed(\'$notchange\')");

print "<SCRIPT language=\"Javascript\">";
print $Jscript;
print "</SCRIPT>";


print h2(&text("net_title",$domain)),$text{"net_attention"},p,
start_form(-method=>"post",-action=>"setnetacl.cgi",-name=>"edit_form");
print hidden(-name=>"domain",-value=>"$domain");
print hidden(-name=>"changed",-value=>"0");


&display_acl("net", "net" ,$text{"net_sock"});
print br;
&display_acl("connect", "connect" ,$text{"net_connect"});
print br;
&display_acl("raw", "raw" ,$text{"net_raw"});
print br;
&display_acl("netlink","netlink",$text{"net_netlink"});
print br;

print br,$text{"net_well_reserve"},br;

&display_reserving_port("tcp", "TCP:", $global_netacl->reserving_tcp, $netacl->reserving_tcp);

&display_reserving_port("udp", "UDP:", $global_netacl->reserving_udp, $netacl->reserving_udp);

print br;
print $text{"net_well_all"},br;
display_acl("welltcp","welltcp","tcp");
display_acl("welludp","welludp","udp");

print p;


print $text{"net_reserve_other"};
print br,"tcp: ";
foreach (@Reserved_tcp)
{
    print checkbox(-name=>"reserved_tcp",-label=>"$_ ",-checed=>"0",-value=>"$_",-onChange=>"set_change()");
}

print br,"udp: ";
foreach (@Reserved_udp)
{
    print checkbox(-name=>"reserved_udp",-label=>"$_ ",-checed=>"0",-value=>"$_",-onChange=>"set_change()");
}
print p;

print p,submit(-value=>$text{"apply"},-onClick=>"unset_change()"),
end_html();


sub display_acl($$$){
    my $struct_element_name=$_[0];
    my $name =$_[1];
    my $label = $_[2];
    my $value_global;
    my $value;
    $value_global = $global_netacl -> $struct_element_name ;
    $value = $netacl -> $struct_element_name;
    
    #can't edit when allowed in global domain
    if ($value_global==1)
    {
	print $text{"ok"}."$label";
    }
    else
    {
	print checkbox(-name=>$name,-label=>$label,-checked=>$value,-onChange=>"set_change()");
    }     
}

sub display_reserving_port($$$){
    my $name = $_[0];
    my $label = $_[1];
    my $txt;
    my $global_port_array_ref = $_[2];
    my $port_array_ref =$_[3];

    print "$label:";
    foreach(@$global_port_array_ref)
    {
	$txt.=$_." ";
    }
    print $txt;
    $txt ="";
    foreach(@$port_array_ref)
    {
	$txt.=$_." ";
    }
    print textfield(-name=>$name,-size=>'30',value=>$txt,-onChange=>"set_change()"),br;
}


sub set_acl_value($$){
    my $filename = $_[0];
    $acl_ref = $_[1];
    
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    
    while(<FILE>){
	#skip spaces in the head of line
	if (/[^\s\t]+.+/)
	{
	    $_=$&;
	}
    
	if (/^allownet[;\s\t]/)
	{
	    my @tmp;
	    my $opt="";
	    my $opt2="";
	    my $port;
	    my $array_ref;
	    @tmp= split(/[\s\t]+/,$_);
	    $opt=$tmp[1];
	    $opt2=$tmp[2];
	    $port=$tmp[3];
	    
	    if ($opt eq ""||$opt eq ";")
	    {
		$acl_ref -> net("1");
	    }
	    if ($opt=~/-raw/)
	    {
		$acl_ref -> raw("1");
	    }
	    if ($opt=~/-netlink/)
	    {
		$acl_ref -> netlink("1");
	    }
	    if ($opt=~/-connect/)
	    {
		$acl_ref -> connect("1");
	    }
	    
	    if ($opt=~/-tcp/)
	    {
		if ($opt2=~/-allport/)
		{
		    $acl_ref -> welltcp("1");
		}
		else
		{
		    if ($port=~/;/)
		    {
			chop $port;
		    }
		    $array_ref = $acl_ref -> reserving_tcp;
		    push @$array_ref ,$port;
		}
	    }
	    
	    if ($opt=~/-udp/)
	    {
		if ($opt2=~/-allport/)
		{
		    $acl_ref -> welludp("1");
		}
		else
		{
		    if ($port=~/;/)
		    {
			chop $port;
		    }
		    $array_ref = $acl_ref -> reserving_udp;
		    push @$array_ref ,$port;
		}
	    }
	}
    }

    close(FILE);

}

sub read_net_acl($) {
    my $filename;
    my $domain=$_[0];

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }
    set_acl_value($filename, $netacl);
}

sub read_net_acl_global() {
    $filename=$Policy_root."/global";
    set_acl_value($filename, $global_netacl);   
}


sub read_reserved_ports($$$$) {
    my $tcp_ref;
    my $udp_ref;
    my $path;
    my $domain;
    my $filename;

    ($tcp_ref,$udp_ref,$path,$domain)=@_;

    opendir(DIR,$path) or die  "could not open $path";
    while ($_=readdir(DIR))
    {
	#skip myself
	if ($_ eq $domain.".a")
	{
	    next;
	}

	if (/\.a$/)
	{
	    $filename=$path."/".$_;
	}
	else
	{
	    next;
	}

	sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

	while (<FILE>)
	{
	    my @s;
	    #skip spaces
	    if (/[^\s\t]+.+/)
	    {
		$_=$&;
	    }
	    #skip comments
	    if (/[\s\t]+\#/||/^\#/)
	    {
		next;
	    }

	    if (/^allownet[;\s\t]/)
	    {
		my @tmp;
		my $opt="";
		my $opt2="";
		my $port;
		@tmp= split(/[\s\t]+/,$_);
		$opt=$tmp[1];
		$opt2=$tmp[2];
		$port=$tmp[3];

		if ($opt=~/-tcp/)
		{
		    if ($opt2=~/-allport/)
		    {
			;
		    }
		    else
		    {
			if ($port=~/;/)
			{
			    chop $port;
			}
			push @$tcp_ref,$port;
		    }
		}

		if ($opt=~/-udp/)
		{
		    if ($opt2=~/-allport/)
		    {
			;
		    }
		    else
		    {
			if ($port=~/;/)
			{
			    chop $port;
			}
			push @$udp_ref,$port;
		    }
		}
	    }
	}

	close(FILE);
    }

    @$tcp_ref=sort {$a <=> $b} @$tcp_ref;
    @$udp_ref=sort {$a <=> $b} @$udp_ref;

    close(DIR);
}
