#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.

#The callback of exc2_perm.cgi

use Fcntl;
use FileHandle;
use CGI qw(:standard);
require './selinux-lib.pl';

#The exclusive name configured
my $exc_name;
my $current_dir;
$exc_name=param("excname");
$current_dir=param("current_dir");

#Domains going to be configured 
#key:domain value:1
my %configured_domain;

#key:domain value:permission
my %permissions;
&get_params(\%permissions,\%configured_domain,$Policy_root);

#print_header();
#print $exc_name;

my %domain_list;
&read_domain_list(\%domain_list,$Policy_root);
delete $domain_list{"global"};#there is no allow exclusive in global domain





my $domain;
#foreach $domain (keys(%domain_list)){
foreach $domain (keys(%configured_domain)){

  #initialize global value( %Domain_allow etc...)
  if ($domain ne "global"){ 
    undef %Domain_allow;
    undef %Domain_allowonly;
    undef %Exc_allow;
    undef %Exc_dir;
    undef %Explicit;
    &read_domain_file_acl($domain);
    &read_exc_file_acl($domain);
  }

  #save lines not related to allow exclusive's ACL
  local @buffer;
  local @skip;
  push @skip,"^allow[\\s\\t]+[^\/]+";#allow <exclusive name> <permission>;
  push @skip,"^allow[\\s\\t]+.+[\\s\\t]+exclusive[\\s\\t]+";#allow <directory> exclusive <exclusive name>
  &read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);

  $Exc_allow{$exc_name}=$permissions{$domain};

  &write_policy_file(\@buffer,$domain,$Policy_root);

}


redirect("exc2_perm.cgi?excname=$exc_name&current_dir=$current_dir");


sub write_policy_file($$$){
  my $buf_ref;
  my $domain;
  my $root;
  my $fh;
  ($buf_ref,$domain,$root)=@_;
  my $filename;

  $filename=&get_domain_filename($domain,$root);

  $fh =FileHandle->new();

  sysopen($fh,"$filename",O_WRONLY|O_TRUNC|O_CREAT) or die "File open error:$filename\n";

  print $fh "{\n";
  foreach (@$buf_ref){
    if($_ eq "\n"){
      ;
    }else{
      print $fh "$_\n";
    }
    if($_=~/}/){
      next;
    }
  }

  #print allow exclusive
  my $dummy;
  &print_exc_file_acl($fh,$domain,$dummy);

  print $fh "}\n";

  close($fh);
}

sub get_params($$$){
  my $permission_ref;
  my $configured_domain_ref;
  my $root;
  ($permission_ref,$configured_domain_ref,$root)=@_;

  my %domain_list;
  &read_domain_list(\%domain_list,$root);


  foreach (keys(%domain_list)){
    if(param("name_$_")==1){
      $$configured_domain_ref{$_}=1;
      #      if(!exists($$permission_ref{$_})){
      #$$permission_ref{$_}="";
      #      }

      if(param("r_$_") eq "on"){
	$$permission_ref{$_}|=$READ;
	#when permission is read,permission "s" is implicitly allowed
	$$permission_ref{$_}|=$SEARCH;
      }
      if(param("w_$_") eq "on"){
	$$permission_ref{$_}|=$WRITE;
      }
      if(param("x_$_") eq "on"){
	$$permission_ref{$_}|=$EXECUTE;
      }
      if(param("s_$_") eq "on"){
	$$permission_ref{$_}|=$SEARCH;
      }
      if(param("c_$_") eq "on"){
	$$permission_ref{$_}|=$EXC_CREATE; 
      }

    }else{
      ;
    }

  }
    return 0;
}



