#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.

use Fcntl;
use FileHandle;
use CGI qw(:standard);
require './selinux-lib.pl';

#the directory configured
my $fullpath;

#key:domain value:permission
my %permissions;
#key:domain value:1 if the domain is configured allow only then 1
my %only_lists;

$fullpath=param("filename");


&get_params(\%permissions,\%only_lists,$Policy_root);

my %domain_list;
&read_domain_list(\%domain_list,$Policy_root);

my $domain;
foreach $domain (keys(%domain_list)){

  #initialize global value( %Domain_allow etc...)
  if ($domain ne "global"){ 
    undef %Domain_allow;
    undef %Domain_allowonly;
    undef %Exc_allow;
    undef %Exc_dir;
    undef %Explicit;
    &read_domain_file_acl($domain);
    &read_exc_file_acl($domain);
  }

  #save lines not related to File ACL
  local @buffer;
  local @skip;
  push @skip,"^allow[\\s\\t]";
  push @skip,"^allowonly[\\s\\t]";
  push @skip,"^deny[\\s\\t]";
  push @skip,"^denyonly[\\s\\t]";
  &read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);

  my $parentdir=&get_belonging_dir($fullpath);
  my $name=&get_filename_from_fullpath($fullpath);
  my $parent_default_perm=calc_default_perm($parentdir,$domain);
  my $perm=$permissions{$domain};
  my $only_flag=$only_lists{$domain};
  my $parent_only_flag;
  $parent_only_flag=&get_only_flag($parentdir);

  &update_file_acl($domain,$parentdir,$parent_default_perm,$name,$perm,$only_flag,$parent_only_flag);

  
  &write_policy_file(\@buffer,$domain,$parentdir,$Policy_root);
}

redirect("file2_perm.cgi?filename=$fullpath");



sub debug_hashprint($$){
  my $hashref;
  my $comment;
  ($hashref,$comment)=@_;
  print hr;
  print "#####$comment",p;
  foreach (keys %$hashref){
    my $str;
    $str=&perm_to_str($$hashref{$_});
    print "$_:$$hashref{$_}",p;
  }
  print hr;
}

sub get_params($$$){
  my $permission_ref;
  my $only_list_ref;
  my $root;
  ($permission_ref,$only_list_ref,$root)=@_;

  my %domain_list;
  &read_domain_list(\%domain_list,$root);

#  print $root;
  foreach (keys(%domain_list)){
    if(param("name_$_")==1){

      if(param("r_$_") eq "on"){
	$$permission_ref{$_}|=$READ;
	#when permission is read,permission "s" is implicitly allowed
	$$permission_ref{$_}|=$SEARCH;
      }
      if(param("w_$_") eq "on"){
	$$permission_ref{$_}|=$WRITE;
      }
      if(param("x_$_") eq "on"){
	$$permission_ref{$_}|=$EXECUTE;
      }
      if(param("s_$_") eq "on"){
	$$permission_ref{$_}|=$SEARCH;
      }
      if(param("deny_$_") eq "on"){
	$$permission_ref{$_}|=$DENY_EXPLICIT;
      }

      if(param("radio_$_") eq "only"){
	$$only_list_ref{$_}=1;
      }

    }else{
      ;
    }

  }

}


#write ACLs to file
sub write_policy_file($$$$){
  my $outfile;
  my $fh;
  my $buf_ref;
  my $current_domain;
  my $current_dir;
  my $root;
  ($buf_ref,$current_domain,$current_dir,$root)=@_;

  $outfile=&get_domain_filename($current_domain,$root);

#  foreach (keys(%Domain_allow)){
#    print "$_:$Domain_allow{$_}",p
#  }


#  print h2($outfile),p;
  $fh =FileHandle->new();
  sysopen($fh,"$outfile",O_WRONLY|O_TRUNC| O_CREAT) or die "no $outfile\n";

  print $fh "{\n";
  foreach (@$buf_ref){
    print $fh "$_\n";
  }
  

  if($current_domain eq "global"){
    print_global_set_file($fh);
  }else{
    print_domain_set_file($fh,$current_domain,$current_dir);
  }

  print $fh "$_}\n";
  close($fh);
  

}
