#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: set_file_acl.cgi,v 1.3 2005/07/15 17:12:43 ynakam Exp $

use Fcntl;
use FileHandle;
use CGI qw(:standard);
#save File ACL,edited by view.cgi
require './selinux-lib.pl';

#
#local $outfile;
#local $fh;#file handle
local $query; #POST string
local $current_dir; #directory where target file belongs
local $current_domain; #domain that is now being configured
local $default_perm; #permission of $current_dir
local %permission; #permission of files/directorys
local %allow_list;
local %only_list; #registared allowonly directorys
local %concerned_file;#this is used to separate file list created by view.cgi
local $start_point=0;


parse_query();

#foreach $key (keys %permission){
#    print $key;
#    print ":";
#    print $permission{$key};
#    print "<br>";
#}
#return;

if ($current_domain ne "global")
{
    &read_domain_file_acl($current_domain);
    &read_exc_file_acl($current_domain);
}

#read only_list of current_dir from policy file
#and save new only_flag
local $new_only_flag_current_dir=$only_list{$current_dir};#selected radio bottun
delete $only_list{$current_dir};
$only_list{$current_dir}=&get_only_flag($current_dir);#uses old value first


#save lines not related to File ACL
local @buffer;
local @skip;
push @skip,"^allow[\\s\\t]";
push @skip,"^allowonly[\\s\\t]";
push @skip,"^deny[\\s\\t]";
push @skip,"^denyonly[\\s\\t]";
&read_conf_file_skip($current_domain,$Policy_root,\@buffer,\@skip);

#save configuration about files under $current_dir
$default_perm=calc_default_perm($current_dir,$current_domain);
&calc_conf($current_domain);
&write_policy_file();

# if ($current_domain eq "global")
# {
#     $fh =FileHandle->new();
#     $outfile=$Policy_root."/global";

#     sysopen($fh,"$outfile",O_WRONLY|O_TRUNC| O_CREAT) or die "no $outfile\n";
#     print $fh "{\n";
#     foreach (@buffer)
#     {
# 	print $fh "$_\n";
#     }
#     print_global_set_file($fh);
#     print $fh "$_}\n";
#     close $fh;
# }
# else
# {
#     &calc_exc_file_acl($current_dir);
#     $fh =FileHandle->new();
#     $outfile=$Policy_root."/$current_domain".".a";

#     sysopen($fh,"$outfile",O_WRONLY|O_TRUNC| O_CREAT) or die "no $outfile\n";
#     print $fh "{\n";
#     foreach (@buffer)
#     {
# 	print $fh "$_\n";
#     }
#     print_domain_set_file($fh,$current_domain,$current_dir);
#     print $fh "$_}\n";
#     close $fh;
# }

#redirect("view.cgi?filepath=$current_dir&domain=$current_domain&start=$start_point");
#exit;


#save configuration about "current_dir"
undef @buffer;
&read_conf_file_skip($current_domain,$Policy_root,\@buffer,\@skip);
&reload_config($current_domain);
&save_conf_of_current_dir();
&write_policy_file();


redirect("view.cgi?filepath=$current_dir&domain=$current_domain&start=$start_point");

#caluculate allow exclusive's ACL
#and write ACLs to file
sub write_policy_file(){
  my $outfile;
  my $fh;

  if($current_domain eq "global"){
    $fh =FileHandle->new();
    $outfile=$Policy_root."/global";

    sysopen($fh,"$outfile",O_WRONLY|O_TRUNC| O_CREAT) or die "no $outfile\n";
    print $fh "{\n";
    foreach (@buffer){
      print $fh "$_\n";
    }
    print_global_set_file($fh);
    print $fh "$_}\n";
  }else{
    &calc_exc_file_acl($current_dir);
    $fh =FileHandle->new();
    $outfile=$Policy_root."/$current_domain".".a";
    sysopen($fh,"$outfile",O_WRONLY|O_TRUNC| O_CREAT) or die "no $outfile\n";
    print $fh "{\n";
    foreach (@buffer)
    {
      print $fh "$_\n";
    }
    print_domain_set_file($fh,$current_domain,$current_dir);
    print $fh "$_}\n";
  }

}


sub save_conf_of_current_dir(){
  #Save configuration to $current_dir
  my $parentdir=&get_belonging_dir($current_dir);
  my $name=&get_filename_from_fullpath($current_dir);
  my $parent_default_perm=calc_default_perm($parentdir,$current_domain);
  my $perm=$permission{$current_dir};
  my $only_flag=$new_only_flag_current_dir;
  my $parent_only_flag;


  $parent_only_flag=&get_only_flag($parentdir);
  &update_file_acl($current_domain,$parentdir,$parent_default_perm,$name,$perm,$only_flag,$parent_only_flag);
}

sub multiple_c_err_exit() {
    &print_header();
    print start_html();
    print $text{"multiple_c_error"},p;
    print a({-href=>"view.cgi?filepath=$current_dir&domain=$current_domain&start=$start_point"},$text{"back"});
    print end_html();

    exit;
}

#parse query and set value in global values
sub parse_query() {  

    my @elements = param();

    #&print_header();
    
    my $c_count=0;		#the number of checked "c" checkboxs.
    for $element (@elements)
    {
	$key = $element;
	$value = param($key);	

#	print "##$key:$value<br>";
	if ($key eq ".")
	{
	    next;
	}

	if ($value eq "domain")
	{
	    $current_domain=$key;
	    next;
	}

	if ($key eq "start")
	{
	    $start_point=$value;
	    next;
	}

	#strip radio_all, radio_only
	if (($key=~/radio_all/||$key=~/radio_only/)&&($value eq "only"||$value eq "all"))
	{
	    $key =~/\/.*/;
	    $key=$&;	 
	}

	#when $key start from name_,$key is the file to be configured
	if ($key=~/name_/)
	{
	    $key=~s/name_//;
	    $concerned_file{$key}=1;
	    #print $key,"<p>";
	    next;
	}
	

	if ($value eq "deny")
	{			#in global domain,explicitly deny exists 
	    #strip deny_
	    $key =~/_.*/;
	    $key=$&;
	    $key =~/[^_].*/;
	    $key=$&;
	    $permission{$key}|=$DENY_EXPLICIT;
	  
	}

	if ($value eq "r")
	{  
	    $key =~/_.*/;
	    $key=$&;
	    $key =~/[^_].*/;
	    $key=$&;
	    
	    $permission{$key}|=$READ;#when permission is read,permission "s" is implicitly allowed
		$permission{$key}|=$SEARCH;
	    next;
	}
	if ($value eq "w")
	{
	    $key =~/_.*/;
	    $key=$&;
	    $key =~/[^_].*/;
	    $key=$&;
	    $permission{$key} |= $WRITE;
	    next;
	}
	if ($value eq "x")
	{
	    $key =~/_.*/;
	    $key=$&;
	    $key =~/[^_].*/;
	    $key=$&;
	    $permission{$key} |= $EXECUTE;
	    next;
	}
	if ($value eq "s")
	{
	    $key =~/_.*/;
	    $key=$&;
	    $key =~/[^_].*/;
	    $key=$&;

	    $permission{$key} |= $SEARCH;
	  
	    next;
	}
	if ($value eq "c")
	{
	    $key =~/_.*/;
	    $key=$&;
	    $key =~/[^_].*/;
	    $key=$&;
	    
	    $permission{$key} |= $EXC_CREATE;
	    $c_count++;
	    if($c_count>1)
	    {
		&multiple_c_err_exit();
	    }
	    next;
	}
	if ($value eq "only")
	{
	    $only_list{$key}=1;
	    next;
	}
	if ($value eq "current")
	{
	    #in hidden tag,current directory is stored
	    $current_dir=$key;
	    next;
	}

    }
}

#calculate File acl configuration to write
#$domain
sub calc_conf($) {
    my $domain;
    local *allowhash;
    local *allowonlyhash;
    ($domain)=@_;

    if ($domain eq "global")
    {
	*allowhash=*Global_allow;
	*allowonlyhash=*Global_allowonly;
    }
    else
    {
	*allowhash=*Domain_allow;
	*allowonlyhash=*Domain_allowonly;
    }

    #configuration to "/"
    if ($current_dir eq "Root")
    {
	my $only_flag;
	my $perm;

	if (exists($only_list{"/"}))
	{
	    $only_flag=1;
	}
	$perm=$permission{"/"};

	&update_allow_hash($domain,"/",$perm,$only_flag);

	return;
    }

    #search $current_dir and update allowhash,allowonlyhash
    opendir(DIR,$current_dir) or die "could not open $current_dir\n";

    while ($_=readdir(DIR))
    {
      ###!!the following codes will be replaced by &update_file_acl()
	my $fullpath;
	my $perm;
	my $only_flag;

	if ($_ eq "."||$_ eq "..")
	{
	    next;
	}

	if ($current_dir eq "/")
	{
	    $fullpath=$current_dir.$_;
	}
	else
	{
	    $fullpath=$current_dir."/".$_;
	}

	#if $fullpath is not included in page(display of view.cgi).
	if (!exists($concerned_file{$fullpath}))
	{
	    next;
	}


	if (!exists($permission{$fullpath}))
	{					#not explicitly configured
	    $permission{$fullpath}=$DENY;
	}

	$perm=$permission{$fullpath};
	if ($perm&$DENY_EXPLICIT)
	{
	    $perm=$DENY_EXPLICIT;
	}

	$only_flag=$only_list{$fullpath};
	if ($only_flag eq "")
	{
	    $only_flag=0;
	}

	#when $fullpath is directory
	if (-d $fullpath)
	{
	    if ($only_list{$current_dir}==1)
	    {
		#allowonly
		if ($perm == $DENY)
		{
		    if (
			#"deny" to $fullpath is described in advance.
			exists($Domain_allow{$fullpath})||exists($Domain_allowonly{$fullpath})
			#When "allow or deny or allowonly or denyonly" to $fullpath is described in global domain,
			#if "deny" is not written,configuration in global domain will
			#overwrite configuratin in normal domain.
			||exists($Global_allow{$fullpath})||exists($Global_allowonly{$fullpath})
			#if denyonly is described to $fullpath,converter must write denyonly
			||$only_flag==1
			)
		    {
			#tell converter to write "deny or denyonly"
			&update_allow_hash($current_domain,$fullpath,$DENY,$only_flag);
		    }
		    else
		    {
			#in this case,access to $fullpath is implicitly denied.
			#so converter shouldn't to write "deny".
			delete $allowhash{$fullpath};
			#delete $allowonlyhash{$fullpath};
		    }
		}
		else
		{
		    #when $perm is not DENY

		    #if some of checkboxs of $fullpath is on,
		    #converter should write "allow".Because permission isn't inherited from parent directory.
		    &update_allow_hash($current_domain,$fullpath,$perm,$only_flag);
		}
	    }
	    else
	    {
		#not allowonly
		if (
		    ####the conditions to write "allow,deny"

		    $perm!=$default_perm
		    ||$only_list{$current_dir}!=$only_list{$fullpath}

		    #this condition is nessesary to overwrite configuration in global domain.
		    ||((exists($Global_allow{$fullpath})
			&&($default_perm!=$Global_allow{$fullpath}))&&($current_domain ne "global"))
		    ||((exists($Global_allowonly{$fullpath})
			&&($default_perm!=$Global_allowonly{$fullpath})&&($current_domain ne "global" ) ))
		    )
		{
		    #tell converter to write "allow or allowonly"
		    &update_allow_hash($current_domain,$fullpath,$perm,$only_flag);
		}
		else
		{
		    #in this case,access to $fullpath is implicitly allowed.
		    #so converter shouldn't to write "allow".
		    delete $allowhash{$fullpath};
		    delete $allowonlyhash{$fullpath};
		}
	    }
	}
	else
	{
	    #When $fullpath is file

	    if ($perm!=$default_perm)
	    {
		&update_allow_hash($current_domain,$fullpath,$perm,$only_flag);
	    }
	    elsif (((exists $Global_allow{$fullpath} ) &&
		    ($default_perm!=$Global_allow{$fullpath}) &&
		    ($current_domain ne "global"))  )
	    {					#this condition is nessesary to overwrite configuration in global domain.
		&update_allow_hash($current_domain,$fullpath,$perm,$only_flag);
	    }
	    else
	    {
		delete $allowhash{$fullpath};
	    }
	}

	#This is "deny" in global domain only
	if ($perm==$DENY_EXPLICIT)
	{
	    &update_allow_hash($current_domain,$fullpath,$DENY,$only_flag);
	}

      }

    #don't write configuration the same as that of global domain.
    foreach $key (keys %Domain_allowonly)
    {
	my $perm;
	$perm=$Domain_allowonly{$key};
	if (exists($Global_allowonly{$key}))
	{
	    if ($perm==$Global_allowonly{$key})
	    {
		delete $Domain_allowonly{$key};
		next;
	    }
	}
    }

    foreach $key(keys %Domain_allow)
    {
	my $perm;
	$perm=$Domain_allow{$key};
	if (exists($Global_allow{$key}))
	{
	    if ($perm==$Global_allow{$key})
	    {
		delete $Domain_allow{$key};
		next;
	    }
	}
    }

    closedir(DIR);
}



