#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: set_new_domain.cgi,v 1.1.1.1 2005/05/25 16:47:04 ynakam Exp $

#save new domain/role
use Fcntl;
use CGI qw(:standard);

require "./common.pl";

local $domain_name;
local $domain_or_role;
local $Policy_root;
local %Domain_list;
local $Template_path;
local $template_name=param("template");
$template_name=~s/\.tem$//;
local @template;#configuration generated by template
local $comment;

$Policy_root=set_policy_root();
$Template_path=$module_root_directory."/template";

$domain_name=param("domain_name");
$domain_or_role=param("select");
$comment=param("comment");

&read_domain_list(\%Domain_list,$Policy_root);

#&print_header();

$domain_name=&make_domain_name($domain_name);

&check_domain_name($domain_name);

&write_new_domain();


if ($domain_or_role eq "domain")
{
    redirect("new_domain.cgi?domain=$domain_name&flag=1");
}
if ($domain_or_role eq "role")
{
    redirect("new_domain.cgi?domain=$domain_name&flag=2");
}

sub error_exit($) {
    my $str=$_[0];
    &print_header();
    start_html();
    print $str;
    end_html();
    exit;
}


#make domain name from $name,according to $domain_or_role flag.
sub make_domain_name($) {
    my $name=$_[0];
    my $domain;

    if ($name=~/_t$/)
    {
	if ($domain_or_role eq "role")
	{
	    $name=~s/_t$/_r/;
	}
	$domain=$name;
    }
    elsif ($name=~/_r$/)
    {
	if ($domain_or_role eq "domain")
	{
	    $name=~s/_r$/_t/;
	}
	$domain=$name;
    }
    else
    {
	if ($domain_or_role eq "role")
	{
	    $domain=$name."_r";
	}
	if ($domain_or_role eq "domain")
	{
	    $domain=$name."_t";
	}
    }

    return $domain;
}


sub check_domain_name($) {
    my $domain_name=$_[0];

    if (exists($Domain_list{$domain_name}))
    {
	$domain_name=&escape_tag($domain_name);
	error_exit(&text("domain_name_error_exist",$domain_name));
	return;
    }

    #a-Z,0-9,_
    if ($domain_name=~/[^a-zA-Z0-9_]/)
    {
	error_exit($text{"domain_name_error_syntax"});
	return;
    }
}


#expand macro into buffer.
sub expand_macro($) {
    my  $tmpfile;
    my $command;
    my $m4=$config{"m4"};
    my $bufref=$_[0];

    $tmpfile="$Template_path"."/tmp";

    sysopen(TMPFILE,"$tmpfile",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$tmpfile\n";;
    print TMPFILE "$template_name"."_template($domain_name)\n";
    close(TMPFILE);

    $command.="$m4 -Imacros -s $Template_path/*.tem $tmpfile > $Template_path/tmp2";
    system($command);

    #delete unnesessary comments
    my @pattern;
    push @pattern,"^#";

    &read_file_skip("$Template_path/tmp2",$bufref,\@pattern);

}


sub write_new_domain() {
    my $filename;
    my @buf;

    $filename=$Policy_root."/$domain_name".".a";

    #open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "#comment:$comment\n";
    print FILE "{\n";

    if ($domain_or_role eq "domain")
    {
	print FILE "domain $domain_name;\n";
	$Domain_list{"$domain_name"}=1;
    }
    else
    {
	print FILE "role $domain_name;\n";
	$Domain_list{"$domain_name"}=2;
    }

    #expand macro,
  #   if ($template_name ne "")
#     {
#       &expand_macro(\@buf);
#       foreach (@buf){
# 	print FILE $_;
#       }
#     }

    print FILE "}\n";
    close(FILE);

    &write_default_type($Policy_root,\%Domain_list);

#  #write default_type
#   $filename=$Policy_root."/default_type";
#   #open(FILE,">$filename") or die "File open error:$filename\n";
#   sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";
#   my $key;
#   foreach $key(keys(%Domain_list)){
#     #when role
#     if($Domain_list{$key}==2){
#       my $role;
#       my $prefix;
#       $role=$key;
#       $prefix=get_prefix($role);
#       print FILE "$role:$prefix"."_t\n";
#     }
#   }
#   close(FILE);

}
