#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setadmacl.cgi,v 1.2 2005/06/23 15:32:12 ynakam Exp $

#save allowadm
use Fcntl;
use CGI qw(:standard);
require "common.pl";


#ACL for administration
#key:the argument of allowadm
#value:1
local %adm_acl;
local @buffer;

local $domain=param("domain");
local $Policy_root=set_policy_root();

&set_acl("relabel");
&set_acl("part_relabel");
&set_acl("getsecurity");
&set_acl("setenforce");
&set_acl("load_policy");
&set_acl("net");
&set_acl("boot");
&set_acl("insmod");
&set_acl("quotaon");
&set_acl("swapon");
&set_acl("swapon");
&set_acl("mount");
&set_acl("raw_io");
&set_acl("ptrace");
&set_acl("chroot");
&set_acl("search");
&set_acl("read");
&set_acl("write");
&set_acl("unlabel");
&set_acl("all");

my @skip;
push @skip,"^allowadm[\\s\\t]";
&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);

&write_config($domain);

redirect("admacl_edit.cgi?domain=$domain");

sub set_acl($) {
    my $name;
    $name=$_[0];

    if (param($name) eq "on")
    {
	$adm_acl{$name}=1;
    }
}


sub write_config($) {
    my $domain;
    my $filename;
    $domain=$_[0];

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

#  open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "{\n";

    foreach (@buffer)
    {
	print FILE "$_\n";
    }

    my $key;
    foreach $key (keys %adm_acl)
    {
	print FILE "allowadm $key".";\n";
	if ($key eq "relabel")
	{
	    print FILE "allowadm getsecurity;\n";
	    print FILE "allowadm search;\n";
	}
    }

    print FILE "}\n";
    close(FILE);
}
