#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setdomain.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

#save domain transition
use Fcntl;
use CGI qw(:standard);
require './domain_trans_lib.pl';
use FileHandle;


local $domain_name;
local $parent_domain;
local @entry_point;
local $delete;
local @buffer;#
local $err_msg;
local $comment;
$domain_name=param("domain_name");
$parent_domain=param("parent_domain");
$comment=param("comment");

if ($comment eq "")
{
    $comment=read_comment($domain_name,$Policy_root);
}

my @tmp;
@tmp=split(/[\s\t]+/,param("entry_text"));
foreach (@tmp)
{
    if ($_ ne "")
    {
	push @entry_point,$_;
    }
}

$delete=param("delete");
if ($delete eq "on")
{
    @entry_point="";
}

if (check_error())
{
    &print_header();
    print $err_msg;

    return ;
}

my $filename=$Policy_root."/"."$domain_name".".a";
&read_set_file($filename);
&update_domain_trans_rule();
&write_set_file($filename);

redirect("domain_trans_reload.cgi");

#If error is detected return 1
#error message is set in $err_msg
sub check_error() {

    if ($domain_name eq "")
    {
	$err_msg="顼:ɥᥤ̾ꤵƤޤ\n";
	return 1;
    }
    if (!exists $Domain{"$domain_name"})
    {
	$err_msg=&text("trans_domain_not_exist",$domain_name);
	return 1;
    }
    foreach (@entry_point)
    {
	if ($_ eq "")
	{
	    next;
	}
	if (!(-e $_))
	{
	    my $filename=$_;
	    $filename=&escape_tag($filename);
	    $err_msg=&text("trans_file_not_exist",$filename);
	    return 1;
	}
    }
    if ($domain_name eq $parent_domain)
    {
	$err_msg=$text{"trans_domain_same"};
	return 1;
    }

    return 0;
}

sub read_set_file() {
    my $filename=$_[0];
    #open(FILE,"<$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	if (/[\{\}]/)
	{
	    next;
	}
	#skip domain,domain_trans
	if (/^[\s\t]*domain/||/^[\s\t]*role/||/^[\s\t]*user/)
	{
	    next;
	}
	push @buffer,$_;
	#print $_,p;
    }

    close(FILE);
}

sub write_set_file() {
    my $fh;
    my $filename=$_[0];

    $fh =FileHandle->new();
    #open($fh,">$filename") or die "no $filename\n";
    sysopen($fh,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "no $filename\n";

    print $fh "#comment:$comment\n";
    print $fh "{\n";
    &write_domain($fh,$domain_name);

    my $ref;
    $ref=$Domain_trans_rule{"$domain_name"};

    foreach (@$ref)
    {
	my $parent;
	my $entry;
	my @tmp;
	@tmp=split(/,/,$_);
	$parent=$tmp[0];
	$entry=$tmp[1];

	if ($tmp[0] eq "" || $tmp[1] eq "")
	{
	    next;
	}

	print $fh "domain_trans $parent $entry;\n";
    }

    foreach (@buffer)
    {
	if (/#comment:/)
	    {
		next;
	    }
	    print $fh $_;
	}

	print $fh "}\n";
}

#update %Domain_trans_rule
sub update_domain_trans_rule() {
    my $ref;
    my @array;
    $ref=$Domain_trans_rule{"$domain_name"};

    @array=@$ref;

    #delete domain whose parent domain is the same
    foreach (@array)
    {
	if (/$parent_domain/)
	{
	    $_="";
	}
    }

  #add parent domain and entry point
    foreach (@entry_point)
    {
	if ($_ eq "")
	{
	    next;
	}
	push @array,"$parent_domain,$_";
    }

    #delete spaces
    my @tmp;
    foreach (@array)
    {
	if ($_ eq "")
	{
	    next;
	}
	push @tmp,$_;
    }
    @$ref=@tmp;
}
