#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setipcacl.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

#save configuration of IPC ACL
use Fcntl;
use CGI qw(:standard);
require "common.pl";

#key:the kind of IPC
#value:domain names which the domain can communicate via IPC,separated by space
local %IPC_acl;
local @buffer;

local $domain=param("domain");
local $Policy_root=set_policy_root();
local %Domain_list;

&read_domain_list(\%Domain_list,$Policy_root);

&set_ipc_acl("-tcp");
&set_ipc_acl("-udp");
&set_ipc_acl("-unix");

&set_ipc_acl("-sem");
&set_ipc_acl("-msg");
&set_ipc_acl("-msgq");
&set_ipc_acl("-shm");
&set_ipc_acl("-pipe");

&set_ipc_acl("c");
&set_ipc_acl("k");
&set_ipc_acl("s");
&set_ipc_acl("o");

my @skip;
push @skip,"^allowcom[\\s\\t]";
&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);
&write_config($domain);


redirect("ipcacl_edit.cgi?domain=$domain");

sub print_error_exit($) {
    my $name=$_[0];

    $name=&escape_tag($name);
    &print_header();
    start_html();
    print  &text("trans_domain_not_exist",$name);
    end_html();
    exit;
}

sub set_ipc_acl($) {
    my $key=$_[0];

    if (param("$key"."_self") eq "on")
    {
	$IPC_acl{$key}.="self ";
    }
    if (param("$key"."_all") eq "on")
    {
	$IPC_acl{$key}.="global ";
    }
    if (param("$key"."_text"))
    {
	#print param("$key"."_text");
	@tmp=split(/[\s\t]+/,param("$key"."_text"));
	foreach (@tmp)
	{
	    if ($_=~/\S/ && !exists($Domain_list{$_}))
	    {
		&print_error_exit($_);
	    }

	    if ($_ ne "")
	    {
		$IPC_acl{$key}.="$_ ";
	    }
	}
    }
}

sub print_param($) {
    my $key=$_[0];

    print "$key:",param("$key"."_self"),p;
    print "$key:",param("$key"."_all"),p;
    print "$key:",param("$key"."_text"),p;
}

sub write_config($) {
    my $domain;
    my $filename;
    $domain=$_[0];

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

#  open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "{\n";
    foreach (@buffer)
    {
	print FILE "$_\n";
    }

    my $key;
    foreach $key (keys %IPC_acl)
    {
	my @domain_list=split(/[\s\t]+/,$IPC_acl{$key});

	if ($key eq "c"||$key eq "k"||$key eq "s"||$key eq "o")
	{
	    foreach (@domain_list)
	    {
		print FILE "allowcom -sig $_ $key".";\n";
	    }
	}
	elsif ($key eq "-tcp"||$key eq "-udp"||$key eq "-unix")
	{
	    foreach (@domain_list)
	    {
		print FILE "allowcom $key $_".";\n";
	    }
	}
	else
	{
	    foreach (@domain_list)
	    {
		print FILE "allowcom $key $_ "."r,w;\n";
	    }
	}
    }

    print FILE "}\n";
    close(FILE);
}
