#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setnetacl.cgi,v 1.3 2005/06/23 15:32:12 ynakam Exp $

#save configuration of network ACL
use Fcntl;
use CGI qw(:standard);
require 'common.pl';


#print CGI::header(-type=>'text/html',-charset=>'EUC_JP');

$net=param("net");
$connect=param("connect");
$raw=param("raw");
$netlink=param("netlink");
$tcp=param("tcp");
$udp=param("udp");
$well=param("wellknown");
$welltcp=param("welltcp");
$welludp=param("welludp");
@reserved_tcp=param("reserved_tcp");
@reserved_udp=param("reserved_udp");

local $Net_allow;
local $Connect_allow;
local $Raw_allow;
local $Netlink_allow;
local $Wellknown_allow;
local $Wellknown_tcp_allow;
local $Wellknown_udp_allow;
local @Allowed_tcp;
local @Allowed_udp;
local $domain=param("domain");
local @buffer;
local $Policy_root=set_policy_root();


if ($net eq "on")
{
    $Net_allow=1;
}

if ($raw eq "on")
{
    $Raw_allow=1;
}
if ($connect eq "on")
{
    $Connect_allow=1;
}
if ($netlink eq "on")
{
    $Netlink_allow=1;
}
if ($welltcp eq "on")
{
    $Wellknown_tcp_allow=1;
    $Wellknown_allow=1;
}

if ($welludp eq "on")
{
    $Wellknown_udp_allow=1;
    $Wellknown_allow=1;
}


my $st;
if ($tcp ne "")
{
    $st=&set_array(\@Allowed_tcp,$tcp);
}
my $st2;
if ($udp ne "")
{
    $st2=&set_array(\@Allowed_udp,$udp);
}

foreach (@reserved_tcp)
{
    push @Allowed_tcp,$_;
    $Wellknown_allow=1;
}
foreach (@reserved_udp)
{
    push @Allowed_udp,$_;
    $Wellknown_allow=1;
}

if ($st==-1||$st2==-1)
{
    &print_header();
    print start_html(-lang=>'japanese',-title=>$text{"net_acl_error_num"}),
    $text{"net_acl_error_num"},
    end_html();

    return;
}

if ($st==-2||$st2==-2)
{
    &print_header();
    print start_html(-lang=>'japanese',-title=>$text{"net_acl_error_range"}),
    $text{"net_acl_error_range"},
    end_html();

    return;
}


my @skip;
push @skip,"^allownet[;\\s\\t]";
&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);
&write_config($domain);

redirect("netacl_edit.cgi?domain=$domain");

sub write_config($) {
    my $domain;
    my $filename;
    $domain=$_[0];
#  read_conf_file($domain);

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

#  open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "{\n";
    foreach (@buffer)
    {
	if (!/}/)
	{
	    print FILE "$_\n";
	}
    }

    if ($Net_allow==1)
    {
	print FILE "allownet;\n";
    }
    if ($Connect_allow==1)
    {
       print FILE "allownet -connect;\n";
    }
    if ($Raw_allow==1)
    {
	print FILE "allownet -raw;\n";
    }

    if ($Netlink_allow==1)
    {
	print FILE "allownet -netlink;\n";
    }

    if ($Wellknown_allow==1)
    {
	print FILE "allownet -wellknown;\n";
    }

    if ($Wellknown_tcp_allow==1)
    {
	print FILE "allownet -tcp -allport;\n";
    }

    if ($Wellknown_udp_allow==1)
    {
	print FILE "allownet -udp -allport;\n";
    }

    foreach (@Allowed_tcp)
    {
	print FILE "allownet -tcp -port $_;\n";
    }
    foreach (@Allowed_udp)
    {
	print FILE "allownet -udp -port $_;\n";
    }

    print FILE "}\n";

    close(FILE);
}

#return -1 if value except number
#return -2 if value is out of range.
sub set_array($$) {
    my $ref;
    my $value;
    ($ref,$value)=@_;

    my @tmp;
    @tmp=split(/[\s\t]+/,$value);

    foreach (@tmp)
    {
	if ($_ eq "")
	{
	    next;
	}
	push @$ref,$_;
    }

    foreach (@$ref)
    {
	if (/\D/)
	{
	    return -1;
	}
	if ($_>1023||$_<0)
	{
	    return -2;
	}
	#to writeallownet -wellknown
	$Wellknown_allow=1;
    }

    return 0;
}
