#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setprocacl.cgi,v 1.1.1.1 2005/05/25 16:47:06 ynakam Exp $

#save ACL of proc filesystem
use Fcntl;
use CGI qw(:standard);
require "common.pl";

#information of "allowproc" is stored.
#key:option of "allowproc". ex:-self
#value:"r"or"w",separated by space
local %proc_acl;

local @buffer;

local $domain=param("domain");
local $Policy_root=set_policy_root();

#print CGI::header(-type=>'text/html',-charset=>'EUC_JP');


&set_acl("-self");
&set_acl("-other");
&set_acl("-system");
&set_acl("-kmsg");
&set_acl("-proc");

my @skip;
push @skip,"^allowproc[\\s\\t]";
&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);
&write_conf_file($domain);

redirect("procacl_edit.cgi?domain=$domain");

sub set_acl($) {
    my $name;
    $name=$_[0];

    if (param($name."_r") eq "on")
    {
	$proc_acl{$name}.=" r";
    }

    if (param($name."_w") eq "on")
    {
	$proc_acl{$name}.=" w";
    }
}


sub write_conf_file($) {
    my $domain;
    my $filename;
    $domain=$_[0];

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

#  open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "{\n";
    foreach (@buffer)
    {
	print FILE "$_\n";
    }

    my $key;
    foreach $key (keys %proc_acl)
    {
	if ($proc_acl{$key}=~/r/)
	{
	    print FILE "allowproc $key r;\n";
	}
	if ($proc_acl{$key}=~/w/)
	{
	    print FILE "allowproc $key w;\n";
	}
    }
    print FILE "}\n";
    close(FILE);
}
