#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.

#Apply templates to policy 
use Fcntl;
use CGI qw(:standard);
require "common.pl";

local $Policy_root=set_policy_root();
local $template_path=$module_root_directory."/template";
local $domain=param("domain");
local $policyfile=&get_domain_filename($domain,$Policy_root);

&print_header();

#get applied templates
my @templates;
my @applied_templates;

&get_template_list(\@templates,$template_path);
foreach(@templates){
  if(param($_) eq "on"){
      push @applied_templates,$_;
  }
}


print &text("template_menu",$domain),p;
print $text{"applied_templates"},p;
foreach (@applied_templates){
  print $_,p;
}

print hr;
print a({-href=>"template.cgi?domain=$domain" },$text{"back"});


###Apply templates
#merge selected templates into @merged_templates
my @merged_templates;
&merge_templates(\@applied_templates,$template_path,$domain,\@merged_templates);
#merge selected templates into policyfile
&merge_template_file(\@merged_templates,,\@applied_templates,$template_path,$domain,$Policy_root);



# sub delete_templates($$$$){
#   my $template_name;
#   my $domain_name;
#   my $template_path;
#   my $policy_root;
#   ($template_name,$domain_name,$template_path,$policy_root)=@_;
#   #get template fullpath
#   my $template_filename;
#   my $s=$template_name;
#   $template_name=~s/_template$/.tem/;
#   $template_filename=$template_name;
#   $template_name=$s;
#   $template_filename=$template_path."/".$template_filename;
#   #
#   my @template_element;
#   sysopen(FILE,"$template_filename",O_RDONLY) or die "File open error:$template_filename\n";
#   while(<FILE>){
#     if($_=~/^[^#]?allow/||$_=~/^[^#]?deny/||$_=~/^[^#]?domain_trans/){
#       #$template_hash{$_}=1;
#       if($_=~/\n/){
# 	chop $_;
#       }
#       push @template_element,$_;
#     }
#   }
#   push @template_element,"#Template:$template_name";
#   close(FILE);
#   #read policy file in @buffer,but skip row existing in template
#   my @buffer;
#   &read_conf_file_skip($domain_name,$policy_root,\@buffer,\@template_element);
#   foreach (@buffer){
#     print $_,p;
#   }
#   print hr;
#   foreach (@template_element){
#     print $_,p;
#   }
#   &write_buf($domain_name,$policy_root,\@buffer);
# }



sub merge_templates($$$){
  my $applied_templates_ref;
  my $template_path;
  my $domain_name;
  my $merged_templates_buf;
  ($applied_templates_ref,$template_path,$domain_name,$merged_templates_buf)=@_;

  my @domain_trans;
  my @allow_file;
  my @deny_file;
  my @other_allow;

  #expand macro to template/tmp2
  my $m4=$config{"m4"};
  $tmpfile="$template_path"."/tmp";
  sysopen(TMPFILE,"$tmpfile",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$tmpfile\n";;
  foreach (@$applied_templates_ref){
    my $template_name=$_;
    print  TMPFILE "$template_name($domain_name)\n";
  }
  close(TMPFILE);
  my $command.="$m4 -Imacros -s $template_path/*.tem $tmpfile > $template_path/tmp2";
  system($command);

  #Read tmp2 in @$merged_templates_buf and delete unnesessary comments
  my @pattern;
  push @pattern,"^#";
  &read_file_skip("$template_path/tmp2",$merged_templates_buf,\@pattern);

  #  &debug_array_print($merged_templates_buf,"Ͳ");

  #Resolve conflict of allow(about file) in template
  my @template_header;
  my @template_allow_file;
  my @template_allow_other;
  &split_buf_into_category($merged_templates_buf,\@template_header,\@template_allow_file,\@template_allow_other);
  my @resolved_conflict_template_allow_file;
  &resolv_conflict_in_template(\@template_allow_file,\@resolved_conflict_template_allow_file);
  @$merged_templates_buf=(@template_header,@resolved_conflict_template_allow_file,@template_allow_other);


  #  &debug_array_print($merged_templates_buf,"Ͳø");
 
}


sub resolv_conflict_in_template($){
  my $allow_file_ref;
  my $resolved_ref;
  ($allow_file_ref,$resolved_ref)=@_;
  my %template_allow;
  my %template_allowonly;

  &make_file_allow_hash(\%template_allow,\%template_allowonly,$allow_file_ref);
  foreach (keys(%template_allow)){
    if(exists($template_allowonly{$_})){
      delete($template_allowonly{$_});
    }
  }
  &convert_allow_hash_to_sentence(\%template_allow,\%template_allowonly,$resolved_ref);

}



#merge allow(related to file ACL) of template into body
sub merge_allow_file($$){
  my $body_ref;
  my $templateallow_ref;
  ($body_ref,$templateallow_ref)=@_;
  my %body_allow;
  my %body_allowonly;
  my %template_allow;
  my %template_allowonly;

  &make_file_allow_hash(\%body_allow,\%body_allowonly,$body_ref);
  &make_file_allow_hash(\%template_allow,\%template_allowonly,$templateallow_ref);

  #merge permission of template into body
  #and resolve conflict
  foreach (keys(%template_allow)){
    my $key=$_;
    my $p=$template_allow{$key};
    if(exists($body_allow{$key})){
      if($body_allow{$key}==0||$p==0){
	$body_allow{$key}=$p;
      }else{
	$body_allow{$key}|=$p;
      }
    }elsif(exists($body_allowonly{$key})){
      delete($body_allowonly{$key});
      $body_allow{$key}=$p;
    }else{
      $body_allow{$key}=$p;
    }
  }
  foreach (keys(%template_allowonly)){
    my $key=$_;
    my $p=$template_allowonly{$key};
    if(exists($body_allowonly{$key})){
      if($body_allowonly{$key}==0||$p==0){
	$body_allowonly{$key}=$p;
      }else{
	$body_allowonly{$key}|=$p;
      }
    }elsif(exists($body_allow{$key})){
      delete($body_allow{$key});
      $body_allowonly{$key}=$p;
    }else{
      $body_allowonly{$key}=$p;
    }
  }

  #convert permission to sentence
  my @merged_allow;
  &convert_allow_hash_to_sentence(\%body_allow,\%body_allowonly,\@merged_allow);
#   foreach (keys(%body_allow)){
#     my $str;
#     my $file=$_;
#     if($body_allow{$_}==$DENY){
#       $str="deny $file;\n";
#     }else{
#       my $perm=&perm_to_str($body_allow{$_});
#       $str="allow $file $perm;\n";
#     }
#     push @merged_allow,$str;
#   }
#   foreach (keys(%body_allowonly)){
#     my $str;
#     my $file=$_;
#     if($body_allowonly{$_}==$DENY){
#       $str="denyonly $file;\n";
#     }else{
#       my $perm=&perm_to_str($body_allowonly{$_});
#       $str="allowonly $file $perm;\n";
#     }
#     push @merged_allow,$str;
#   }

  return @merged_allow;
}


sub debug_print_allow($){
  my $hash_ref=$_[0];
  foreach (keys(%$hash_ref)){
    print $_;
    print ",";
    my $str=&perm_to_str($$hash_ref{$_});
    print $str,p;
  }

}

sub debug_array_print($$){
  my $comment;
  my $array_ref;
  ($array_ref,$comment)=@_;
  print hr;
  print $comment,p;
  foreach (@$array_ref){
    print $_,br;
  }
  print hr;
}

#merge template into policy file
sub merge_template_file($$$$$){
  my $merged_templates_buf;
  my $applied_templates_ref;
  my $template_path;
  my $domain_name;
  my $policy_root;
  ($merged_templates_buf,$applied_templates_ref,$template_path,$domain_name,$policy_root)=@_;

  ###set arrays from policy file
  my @policy_buf;
  my @policy_header;
  my @policy_allow_file;
  my @policy_allow_other;
  my @skip;
  my $filename=&get_domain_filename($domain_name,$policy_root);
  &read_file_in_buf($filename,\@policy_buf);
  &split_buf_into_category(\@policy_buf,\@policy_header,\@policy_allow_file,\@policy_allow_other);

#  &debug_array_print(\@policy_buf,"");
#  &debug_array_print(\@policy_header,"إå");
#  &debug_array_print(\@policy_allow_file,"եallow");
#  &debug_array_print(\@policy_allow_other,"¾");


  ###set arrays from template files
  my @template_header;
  my @template_allow_file;
  my @template_allow_other;
  &split_buf_into_category($merged_templates_buf,\@template_header,\@template_allow_file,\@template_allow_other);

  ###merge files
  my @merged_file;
  my @merged_header;
  my @merged_allow_file;
  my @merged_allow_other;

  #merge header
  @merged_header=@policy_header;
  foreach (@$applied_templates_ref){
    unshift @merged_header,"#Template:$_\n";
  }
  foreach (@template_header){
    push @merged_header,$_;
  }

  #merge allow( related to file acl)
  @merged_allow_file=&merge_allow_file(\@policy_allow_file,\@template_allow_file);

  #merge other
  @merged_allow_other=@policy_allow_other;
  #strip "}"
  my $popped;
  while(!($popped=~/}/)){
    $popped=pop @policy_allow_other;
  }
  @merged_allow_other=(@policy_allow_other,@template_allow_other);
  push @merged_allow_other,"}\n";


  #merge all
  @merged_file=(@merged_header,@merged_allow_file,@merged_allow_other);
  #  &debug_array_print(\@merged_file,"ޡΥե");
  &write_buf($domain_name,$policy_root,\@merged_file,1)

}


#split buf into 3 arrays
#header:domain,role,user,domain_trans
#allowfile:allow,deny allowonly,denyonly 
#other:allow(exclusive),allowxxx
sub split_buf_into_category($$$$){
  my $buf_ref;
  my $header_ref;
  my $allowfile_ref;
  my $other_ref;
  ($buf_ref,$header_ref,$allowfile_ref,$other_ref)=@_;
  foreach (@$buf_ref){
      my $cat;
    $cat=&check_category($_);
    if($cat eq "header"){
      push @$header_ref,$_;
    }elsif($cat eq "allowfile"){
      push @$allowfile_ref,$_;
    }elsif($cat eq "other"){
      push @$other_ref,$_;
    }else{
      print "Bug!!";die;
    }
  }
}


#check input is header,allow(file),or other
sub check_category($){
  my $line=$_[0];
  #allowexclusive
  if ($line=~/[\s\t]exclusive[\s\t]/) {
    return "other";
  }
  if($line=~/^allow[\s\t]+/ ) {
    $line=~/\/\S*/;
    my $path=$&;
     if ($path!~/\//) {	
       #allow exclusive
       return "other";
     }else{
       return "allowfile";
     }
  }elsif($line=~/^deny[\s\t]+/||
	 $line=~/[\s\t]*denyonly[\s\t]+/||
	 $line=~/^allowonly[\s\t]+/){
    return "allowfile";
  }elsif($line=~/^[^#]?allow/||
	 $line=~/^[^#]?deny/||
	 $line=~/^[^#]?}/){
    return "other";
  }else{
    return "header";
  }
  return "error";
}
