#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: settmpfsacl.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

#save tmpfs ACL
use Fcntl;
use CGI qw(:standard);
require "./common.pl";

#Information of ACL of tmpfs filesystem.
#key:"r" or "w",value:domain names,separated by space
local %tmpfs_acl;

#if domain can create file in tmpfs , this is 1.
local $tmpfs_create_flag;

local @buffer;
local $domain=param("domain");
local $Policy_root=set_policy_root();
local %Domain_list;
&read_domain_list(\%Domain_list,$Policy_root);


&set_acl();

my @skip;
push @skip,"^allowtmpfs[\\s\\t]";
&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);

&write_config($domain);

redirect("tmpfsacl_edit.cgi?domain=$domain");

sub write_config($) {
    my $filename;
    $domain=$_[0];

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

    #  open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    print FILE "{\n";
    foreach (@buffer)
    {
	print FILE "$_\n";
    }
    if ($tmpfs_create_flag==1)
    {
	print FILE "allowtmpfs -create;\n";
    }

    my $key;
    foreach $key (keys(%tmpfs_acl))
    {
	if ($key eq "r")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$tmpfs_acl{"r"});
	    foreach(@tmp)
	    {
		if ($_ eq "")
		{
		    next;
		}
		print FILE "allowtmpfs $_ r;\n"
		}
	}

	if ($key eq "w")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$tmpfs_acl{"w"});
	    foreach(@tmp)
	    {
		if ($_ eq "")
		{
		    next;
		}
		print FILE "allowtmpfs $_ w;\n"
		}
	}
    }

    print FILE "}\n";
    close FILE;
}

sub set_acl() {
    my @texts;

    if (param("tmpfs_create") eq "on")
    {
	$tmpfs_create_flag=1;
    }

    if (param("tmpfs_read_general") eq "on")
    {
	$tmpfs_acl{"r"}.=" "."general";
    }

    if (param("tmpfs_read_all") eq "on")
    {
	$tmpfs_acl{"r"}.=" "."global";
    }

    if (param("tmpfs_read_text"))
    {
	$tmpfs_acl{"r"}.=" ".param("tmpfs_read_text");
	push @texts,param("tmpfs_read_text");
    }

    if (param("tmpfs_write_general") eq "on")
    {
	$tmpfs_acl{"w"}.=" "."general";
    }

    if (param("tmpfs_write_all") eq "on")
    {
	$tmpfs_acl{"w"}.=" "."global";
    }

    if (param("tmpfs_write_text"))
    {
	$tmpfs_acl{"w"}.=" ".param("tmpfs_write_text");
	push @texts,param("tmpfs_write_text");
    }

    &chk_params(\@texts,\%Domain_list);
}
