#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setttyacl.cgi,v 1.1.1.1 2005/05/25 16:47:06 ynakam Exp $


use Fcntl;
use CGI qw(:standard);
require "./common.pl";


#all roles
local %Role_list;

#ACL for tty
#key:create value:1
#key:r,value:role name or global or general
#key:w,value:role name or global or general
local %TTY_acl;

#ACL for pts
#key:create value:1
#key:r,value:role/domain name or global or general
#key:w,value:role/domain name or global or general
#key:change, value: role/domain name
local %PTS_acl;

local @buffer;

#print CGI::header(-type=>'text/html',-charset=>'EUC_JP');
local $domain=param("domain");
local $Policy_root=set_policy_root();
local %Domain_list;
&read_domain_list(\%Domain_list,$Policy_root);


&set_tty_acl();
&set_pts_acl();

my @skip;
push @skip,"^allowtty[\\s\\t]";
push @skip,"^allowpts[\\s\\t]";
&read_conf_file_skip($domain,$Policy_root,\@buffer,\@skip);
&write_config($domain);

redirect("ttyacl_edit.cgi?domain=$domain");



sub set_tty_acl() {

    my @texts;

    if (param("ttycreate") eq "on")
    {
	$TTY_acl{"create"}=1;
    }

    if (param("tty_r_general") eq "on")
    {
	$TTY_acl{"r"}.=" "."general";
    }

    if (param("tty_r_all") eq "on")
    {
	$TTY_acl{"r"}.=" "."global";
    }

    if (param("tty_r_text") ne "")
    {
	$TTY_acl{"r"}.=" ".param("tty_r_text");
	push @texts,param("tty_r_text");
    }

    if (param("tty_w_general") eq "on")
    {
	$TTY_acl{"w"}.=" "."general";
    }

    if (param("tty_w_all") eq "on")
    {
	$TTY_acl{"w"}.=" "."global";
    }

    if (param("tty_w_text") ne "")
    {
	$TTY_acl{"w"}.=" ".param("tty_w_text");
	push @texts,param("tty_w_text");
    }

    if (param("tty_change_general") eq "on")
    {
	$TTY_acl{"change"}.=" "."general";
    }

    if (param("tty_change_all") eq "on")
    {
	$TTY_acl{"change"}.=" "."global";
    }

    if (param("tty_change_text") ne "")
    {
	$TTY_acl{"change"}.=" ".param("tty_change_text");
	push @texts,param("tty_change_text");
    }

    &chk_params(\@texts,\%Domain_list);
}


sub set_pts_acl() {
    my @texts;

    if (param("ptscreate") eq "on")
    {
	$PTS_acl{"create"}=1;
    }

    if (param("pts_r_general") eq "on")
    {
	$PTS_acl{"r"}.=" "."general";
    }

    if (param("pts_r_all") eq "on")
    {
	$PTS_acl{"r"}.=" "."global";
    }

    if (param("pts_r_text") ne "")
    {
	$PTS_acl{"r"}.=" ".param("pts_r_text");
	push @texts,param("pts_r_text");
    }

    if (param("pts_w_general") eq "on")
    {
	$PTS_acl{"w"}.=" "."general";
    }

    if (param("pts_w_all") eq "on")
    {
	$PTS_acl{"w"}.=" "."global";
    }

    if (param("pts_w_text") ne "")
    {
	$PTS_acl{"w"}.=" ".param("pts_w_text");
	push @texts,param("pts_w_text");
    }

    if (param("pts_change_general") eq "on")
    {
	$PTS_acl{"change"}.=" "."general";
    }

    if (param("pts_change_all") eq "on")
    {
	$PTS_acl{"change"}.=" "."global";
    }

    if (param("pts_change_text") ne "")
    {
	$PTS_acl{"change"}.=" ".param("pts_change_text");
	push @texts,param("pts_change_text");
    }

    &chk_params(\@texts,\%Domain_list);
}


sub write_config($) {
    my $domain;
    my $filename;
    $domain=$_[0];

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

    #  open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    my $chsid_flag=0;

    print FILE "{\n";
    foreach (@buffer)
    {
	print FILE "$_\n";
	if ($_=~/allowadm/&&$_=~/chsid/)
	{
	    $chsid_flag=1;
	}
    }

    my $key;
    foreach $key(keys %TTY_acl)
    {
	if ($key eq "create" && $TTY_acl{"create"}==1)
	{
	    print FILE "allowtty -create;\n";
	}

	if($key eq "r")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$TTY_acl{"r"});
	    foreach (@tmp)
	    {
		if ($_ eq "")
		{
		    next;
		}
		print FILE "allowtty $_ r;\n";
	    }
	}

	if ($key eq "w")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$TTY_acl{"w"});
	    foreach (@tmp)
	    {
		if ($_ eq "")
		{
		    next;
		}
		print FILE "allowtty $_ w;\n";
	    }
	}
	if ($key eq "change")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$TTY_acl{"change"});
	    my $t;
	    foreach $t (@tmp)
	    {
		if ($t eq "")
		{
		    next;
		}
		print FILE "allowtty -change $t;\n";
		if ($chsid_flag==0)
		{
		    print FILE "allowadm chsid;\n";
		}
	    }
	}
    }

    foreach $key(keys %PTS_acl)
    {
	if ($key eq "create" && $PTS_acl{"create"}==1)
	{
	    print FILE "allowpts -create;\n";
	}
	if ($key eq "r")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$PTS_acl{"r"});
	    foreach (@tmp)
	    {
		if ($_ eq "")
		{
		    next;
		}
		print FILE "allowpts $_ r;\n";
	    }
	}
	if ($key eq "w")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$PTS_acl{"w"});
	    foreach (@tmp)
	    {
		if ($_ eq "")
		{
		    next;
		}
		print FILE "allowpts $_ w;\n";
	    }
	}

	if ($key eq "change")
	{
	    my @tmp;
	    @tmp=split(/[\s\t]+/,$PTS_acl{"change"});
	    my $t;

	    foreach $t (@tmp)
	    {
		if ($t eq "")
		{
		    next;
		}

		print FILE "allowpts -change $t;\n";
		if ($chsid_flag==0)
		{
		    print FILE "allowadm chsid;\n";
		}
	    }
	}
    }

    print FILE "}\n";

    close FILE;
}
