#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: setuser_role.cgi,v 1.2 2005/06/23 18:53:59 ynakam Exp $

#save configuration by user_role.cgi
use CGI qw(:standard);
use Fcntl;
require "./common.pl";

local $Policy_root=set_policy_root();


&init_config();

local $roles;
local $user;
local @roles;#store roles which user can use
local %role_list;
&read_domain_list(\%role_list,$Policy_root);

foreach (keys(%role_list))
{
    if (!/_r$/)
    {
	delete($role_list{$_});
    }
}
local @role_array=keys %role_list;
@role_array=sort(@role_array);

#print CGI::header(-type=>'text/html',-charset=>'EUC_JP');
$roles=param("role");
$user=param("user_list");
$default_role=param("default_role_select");

#check whether $user is valid
if (!($user=~/\w/))
{
    redirect("user_role.cgi");
    return;
}




my @tmp=split(/[\s\t]+/,$roles);
foreach (@tmp)
{
    if ($_ eq "")
    {
	next;
    }
    push @roles,$_;
}

chk_params(\@roles,\%role_list);


my %roles;
foreach (@roles)
{
    $roles{$_}=1;
}


my @skip;
push @skip,"^user[\\s\\t]";
push @skip,"^role[\\s\\t]";


foreach $role(@role_array)
{
    my %users;
    my @buf;

    %users=get_user($Policy_root,$role);

    #delete "user $user;" from all roles
    if (exists($users{$user}))
    {
	delete $users{$user};
    }

    #add "user $user;" to related role
    if (exists($roles{$role}))
    {
	$users{$user}=1;
    }

    &read_conf_file_skip($role,$Policy_root,\@buf,\@skip);
    &write_conf_file($Policy_root,$role,\%users,\@buf);
}



&write_default_context($user,$default_role,$path);


redirect("user_role.cgi?user=$user");

#return hash table of user names which can use $role
sub get_user($$) {
    my $root;
    my $role;
    ($root,$role)=@_;

    my $filename;
    my %users;
    $filename=$root."/$role".".a";


    #open(FILE,"<$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	my $line=$_;
	#skip spaces
	if ($line=~/[^\s\t]+.+/)
	{
	    $line=$&;
	}

	#search "user" and register user name with %users
	if ($line=~/^user/)
	{
	    my @s;
	    my $user;
	    @s=split(/[\s\t]+/,$line);
	    $user=$s[1];
	    #strip ';' at the end of line.
	    if ($user=~/;/)
	    {
		chop($user);
	    }
	    $users{$user}=1;
	}
    }

    close(FILE);

    return %users;
}


sub write_conf_file($$$) {
    my $role;
    my $filename;
    my $users_ref;
    my $buffer_ref;
    ($path,$role,$users_ref,$buffer_ref)=@_;

    $filename=$path."/$role".".a";

    #   open(FILE,">$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";


    print FILE "{\nrole $role;\n";

    foreach (keys(%$users_ref))
    {
	print FILE "user $_;\n";
    }

    foreach (@$buffer_ref)
    {
	print FILE "$_\n";
    }

    print FILE "}\n";

    close(FILE);
}


sub write_default_context($$$) {
    my $user;
    my $role;
    my $path;
    my @buffer;
    ($user,$role,$path)=@_;


    my @login_domains;	#domain name lists related to /bin/login
    my @sshd_domain;	#domain name related to /usr/sbin/sshd

    @login_domains=&get_prog_domains($path,$config{"login_path"});
    @sshd_domain=&get_prog_domains($path,$config{"sshd_path"});


    #read $username_default_contexts
    my $filename=$path."/$user"."_default_contexts";
    if (-e $filename)
    {
	sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

	while (<FILE>)
	{
	    my $line=$_;
	    my $d;
	    my $skipflag=0;
	    foreach $d (@login_domains)
	    {
		if ($line=~/$d/)
		{
		    $skipflag=1;
		}
	    }
	    foreach $d (@sshd_domain)
	    {
		if ($line=~/$d/)
		{
		    $skipflag=1;
		}
	    }

	    if ($skipflag==1)
	    {
		next;
	    }
	    push @buffer,$line;
	}
	close(FILE);
    }

    #write $username_default_contexts
    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";

    foreach (@buffer)
    {
	print FILE $_;
    }

    if ($role=~/\w/)
    {
	foreach (@login_domains)
	{
	    my $str = make_default_context_str($role, $_);
	    print FILE $str;
	}
	foreach (@sshd_domain)
	{
	    my $str = make_default_context_str($role, $_);
	    print FILE $str;
	}
    }

    close(FILE);
}

sub make_default_context_str($$){
    my $role=$_[0];
    my $prog_domain=$_[1];
    my $prefix;
    my $str;
    $str = "system_r:$prog_domain\t";
    $prefix = &get_prefix($role);
    $str.="$role".":"."$prefix"."_t";
    foreach(@role_array){
	$prefix=&get_prefix($_);
	$str.="\t$_".":"."$prefix"."_t";
    }
    $str.="\n";
    return $str;
}
