#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.

#Display to apply template
use Fcntl;
use CGI qw(:standard);
require "./common.pl";

local $Policy_root=set_policy_root();
local $template_path=$module_root_directory."/template";
local $domain;

$domain=param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html></html>";

  return;
}

&print_header();
print start_html(-title=>$text{"apply_template"});
print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";
print "<SCRIPT language=\"JavaScript\" src=\"template.js\"></SCRIPT>\n";

print h2(&text("template_menu",$domain));
print start_form(-method=>"post",-action=>"settemplate.cgi",-name=>"edit_form");
print hidden(-name=>"domain",-value=>"$domain");
print hidden(-name=>"changed",-value=>"0");

my @table;
print table({-border=>0});
push @table,td({-align=>"center",-bgcolor=>"yellow"},[$text{"apply"},$text{"template"},$text{"comment"}]);

my @list;#template list
my %comment_list;#comment hash key=template name

&get_template_list(\@list,$template_path);

@list=sort @list;
foreach(@list){
  &make_field(\@table,$_,$domain,$Policy_root);
}


print table(Tr(\@table));

print submit(-value=>$text{"apply"});
print end_form();
print end_html();


#construct row
sub make_field($$$) {
  my $table_ref;
  my $template_name;
  my $domain_name;
  my $policy_root;
  ($table_ref,$template_name,$domain_name,$policy_root)=@_;

  #make template's filename
  my  $template_filename;
  my $s=$template_name;
  $template_name=~s/_template$/.tem/;
  $template_filename=$template_name;
  $template_name=$s;
  
  $cbstr=checkbox(-name=>"$template_name",label=>"",-value=>"on",-checked=>0);

  #check if the template is already applied
  my $check;
  my $filename=&get_domain_filename($domain_name,$policy_root);
  $check=&check_match($filename,"^[\s\t]?#Template:$template_name");
  if($check){
    $class="red";
  }else{
    $class="blue";
  }

  my $name="template/$template_filename";
  my $template_link=a({-href=>"javascript:open_subwin(\'$name\',\'500\',\'300\')",-class=>$class},$template_name);


  push @$table_ref,td([$cbstr,$template_link,$text{$template_name}]);
}

