#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: tmpfsacl_edit.cgi,v 1.1.1.1 2005/05/25 16:47:04 ynakam Exp $

#tmpfsե륷ƥꡢɽ
use Fcntl;
use CGI qw(:standard);
require "common.pl";


local $Policy_root=set_policy_root();
local $domain;
$domain=param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html> </html>";

    return;
}

#Information of ACL of tmpfs filesystem.
#key:"r" or "w",value:domain names,separated by space
local %tmpfs_acl;
local %Global_tmpfs_acl;

#1,if domain can create file in tmpfs.
local $tmpfs_create_flag;
local $Global_tmpfs_create_flag;

#Domain names which can create file in tmpfs
#key:domainname ,value:1
local %Domain_list;
&read_tmpfs_create_list(\%Domain_list,$Policy_root);


&read_tmpfs_acl($domain,\%tmpfs_acl,\$tmpfs_create_flag);
if ($domain ne "global")
{
    &read_tmpfs_acl("global",\%Global_tmpfs_acl,\$Global_tmpfs_create_flag);
}

&print_table();

sub print_table() {
    &print_header();
    my $notchange=$text{"notchanged"};
    print start_html(-lang=>'japanese',-title=>$text{"tmpfs_acl"},-onUnload=>"check_changed(\'$notchange\')");
    print "<SCRIPT language=\"JavaScript\" src=\"ttyacl_edit.js\"></SCRIPT>\n";

    print h2(&text("tmpfs_acl_title",$domain));

    my $checkstr;

    print start_form(-method=>"post",-action=>"settmpfsacl.cgi",-name=>"edit_form");
    print hidden(-name=>"domain",-value=>"$domain");
    print hidden(-name=>"changed",-value=>"0");


    if ($Global_tmpfs_create_flag==1)
    {
	$checkstr="";
    }
    else
    {
	my $checked=0;
	if ($tmpfs_create_flag==1)
	{
	    $checked=1;
	}
	$checkstr=checkbox(-name=>"tmpfs_create",-label=>"",-value=>"on",-checked=>"$checked",-onChange=>"set_change()");
    }
    if ($domain ne "global")
    {
	print $text{"tmpfs_create"},$checkstr,p;
    }
    my @table;

    push @table,td(["",$text{"before_label"},$text{"all"},"",""]);

    &make_field(\@table,"tmpfs_read",\%Global_tmpfs_acl,\%tmpfs_acl,"r");
    &make_field(\@table,"tmpfs_write",\%Global_tmpfs_acl,\%tmpfs_acl,"w");

    print table(Tr(\@table));
    print submit(-value=>$text{"apply"},-onClick=>"unset_change()");
    print end_form();
    print end_html();
}


sub make_field() {
    my $table_ref;
    my $name;
    my $global_hash;
    my $hash;
    my $perm;
    ($table_ref,$name,$global_hash,$hash,$perm)=@_;

    my  $menustr;
    my  $value;

    if ($perm eq "r")
    {
	$menustr=$text{"read"};
    }
    elsif ($perm eq "w")
    {
	$menustr=$text{"write"};
    }
    my $check1=0;
    my $check2=0;
    my @tmp;
    @tmp=split(/[\s\t]+/,$$hash{$perm});
    foreach(@tmp)
    {
	if ($_ eq "general")
	{
	    $check1=1;
	    next;
	}
	if ($_ eq "global")
	{
	    $check2=1;
	    next;
	}
	$value.=" ".$_;
    }

    my $global_check1=0;
    my $global_check2=0;
    my $str;
    @tmp=split(/[\s\t]+/,$$global_hash{$perm});
    foreach (@tmp)
    {
	if ($_ eq "general")
	{
	    $global_check1=1;
	    next;
	}
	if ($_ eq "global")
	{
	    $global_check2=1;
	    next;
	}
	$str.=" ".$_;
    }

    my $check1str;
    my $check2str;

    if ($global_check1==1)
    {
	$check1str="";
    }
    else
    {
	$check1str=checkbox(-name=>"$name"."_general",-value=>"on",label=>"",-checked=>$check1,-onChange=>"set_change()");
    }

    if ($global_check2==1)
    {
	$check2str="";
    }
    else
    {
	$check2str=checkbox(-name=>"$name"."_all",-value=>"on",label=>"",-checked=>$check2,-onChange=>"set_change()");
    }

#  delete $Domain_list{$domain};
    delete $Domain_list{"global"};
    delete $Domain_list{"general"};


    my $selectstr;
    my  @domain_array=keys %Domain_list;
    @domain_array=sort @domain_array;
    unshift @domain_array,"";

    my $msg=$text{"add_text_box"};
    $selectstr=$text{"choose"}.scrolling_list(-name=>"$name"."_list",-values=>\@domain_array,-size=>1,-onChange=>"select_domain(\'$name\',\'$msg\')");

    push @$table_ref,td([$menustr,$check1str,$check2str,$str.textfield(-name=>"$name"."_text",-value=>"$value",-onChange=>"set_change()"),$selectstr]);
}

sub read_tmpfs_acl($$$) {
    my $domain;
    my $hash_ref;
    my $filename;
    my $create_flag_ref;

    ($domain,$hash_ref,$create_flag_ref)=@_;

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

    #open(FILE,"<$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	#skip spaces
	if (/[^\s\t]+.+/)
	{
	    $_=$&;
	}

	if (/^allowtmpfs[\s\t]/)
	{
	    my @tmp;
	    my $opt;
	    my $perm;
	    @tmp= split(/[\s\t]+/,$_);
	    $opt=$tmp[1];
	    $permstr=$tmp[2];
	    if ($permstr=~/;/)
	    {
		chop($permstr);
	    }
	    if ($opt eq "-create"||$opt eq "-create;")
	    {
		$$create_flag_ref=1;
	    }
	    else
	    {
		my $d=$opt;
		if ($permstr=~/r/)
		{
		    $$hash_ref{"r"}.=" ".$d;
		}
		if ($permstr=~/w/)
		{
		    $$hash_ref{"w"}.=" ".$d;
		}
	    }
	}
    }

    close(FILE);
}

sub read_tmpfs_create_list() {
    my $ref;
    my $path;
    my $filename;
    ($ref,$path)=@_;

    opendir(DIR,$path) or die  "could not open $path";
    while ($_=readdir(DIR))
    {
	if (/\.a$/)
	{
	    $filename=$path."/".$_;
	}
	elsif ($_ eq "global")
	{
	    $filename=$path."/".$_;
	}
	else
	{
	    next;
	}

#     open(FILE,"<$filename") or die "File open error:$filename\n";
	sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

	my $dname;

	while(<FILE>)
	{
	    my @s;
	    #skip spaces
	    if (/[^\s\t]+.+/)
	    {
		$_=$&;
	    }

	    #skip comments
	    if ( /[\s\t]+\#/||/^\#/)
	    {
		next;
	    }

	    if (/^domain[\s\t]/)
	    {
		@s=split(/[\s\t]+/,$_);
		$dname=$s[1];
		if ($dname=~/;/)
		{
		    chop($dname);
		}
	    }

	    if (/^role[\s\t]/)
	    {
		@s=split(/[\s\t]+/,$_);
		$dname=$s[1];

		if ($dname=~/;/)
		{
		    chop($dname);
		}
	    }

	    if (/^allowtmpfs[\s\t]/)
	    {
		$$ref{$dname}=1;
		last;
	    }
	}
	close(FILE);
    }
    close(DIR);
}
