#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: ttyacl_edit.cgi,v 1.1.1.1 2005/05/25 16:47:06 ynakam Exp $

##
use Fcntl;
use CGI qw(:standard);
require "./common.pl";

#all domain names
local %Domain_list;

#ACL for tty
#key:create value:1
#key:r,value:role name or global or general
#key:w,value:role name or global or general
local %Global_TTY_acl;
local %TTY_acl;

#ACL for pts
#key:create value:1
#key:r,value:role/domain name or global or general
#key:w,value:role/domain name or global or general
#key:change, value: role/domain name
local %Global_PTS_acl;
local %PTS_acl;

local $Policy_root=set_policy_root();

local $domain;
$domain=param("domain");
if ($domain eq "")
{
    &print_header();
    print "<html></html>";

    return;
}

local %Domain_list_bak;
&read_domain_list(\%Domain_list,$Policy_root);
%Domain_list_bak=%Domain_list;

#print CGI::header(-type=>'text/html',-charset=>'EUC_JP');

&read_tty_acl($domain,\%TTY_acl);
if ($domain ne "global")
{
    &read_tty_acl("global",\%Global_TTY_acl);
}

&read_pts_acl($domain,\%PTS_acl);
if ($domain ne "global")
{
    &read_pts_acl("global",\%Global_PTS_acl);
}


&print_table();

sub print_table() {

    &print_header();

    my $notchange=$text{"notchanged"};
    print start_html(-title=>$text{"tty_acl"},-onUnload=>"check_changed(\'$notchange\')"),
    h2(&text("tty_title",$domain)),p;
    print "<SCRIPT language=\"JavaScript\" src=\"ttyacl_edit.js\"></SCRIPT>\n";


    print start_form(-method=>"post",-action=>"setttyacl.cgi",-name=>"edit_form");
    print hidden(-name=>"domain",-value=>"$domain");
    print hidden(-name=>"changed",-value=>"0");


    my @table;
    print table({-border=>0});
    push @table,td({-colspan=>"4",-align=>"center",-bgcolor=>"yellow"},[$text{"tty_menu"}]);


    my $ttychk;
    if ($Global_TTY_acl{"create"}==1)
    {
	$ttychk=$text{"ok"};
    }
    else
    {
	my $checked=0;
	if ($TTY_acl{"create"}==1)
	{
	    $checked=1;
	}
	$ttychk=checkbox(-name=>"ttycreate",label=>"",checked=>"$checked",-onChange=>"set_change()");
    }
    push @table,td([$text{"tty_create"},$ttychk]);

    push @table,td(["",$text{"tty_before_label"},$text{"all"},$text{"individual"}]);

    &make_field(\@table,"tty_r",\%Global_TTY_acl,\%TTY_acl,"r");
    &make_field(\@table,"tty_w",\%Global_TTY_acl,\%TTY_acl,"w");
    &make_field(\@table,"tty_change",\%Global_TTY_acl,\%TTY_acl,"change");

    push @table,td({-colspan=>"4",-align=>"center",-bgcolor=>"yellow"},[$text{"pts_menu"}]);
    my $ptschk;
    if ($Global_PTS_acl{"create"}==1)
    {
	$ptschk=$text{"ok"};
    }
    else
    {
	my $checked=0;
	if ($PTS_acl{"create"}==1)
	{
	    $checked=1;
	}
	$ptschk=checkbox(-name=>"ptscreate",label=>"",checked=>"$checked",-onChange=>"set_change()");
  }

    %Domain_list=%Domain_list_bak;

    push @table,td([$text{"tty_create"},$ptschk]);
    push @table,td(["",$text{"tty_before_create"},$text{"all"},$text{"individual"}]);
    &make_field(\@table,"pts_r",\%Global_PTS_acl,\%PTS_acl,"r");
    &make_field(\@table,"pts_w",\%Global_PTS_acl,\%PTS_acl,"w");
    &make_field(\@table,"pts_change",\%Global_PTS_acl,\%PTS_acl,"change");

    print $text{"tty_attention"},p;

    push @table,td([submit(-value=>$text{"apply"},-onClick=>"unset_change()")]);

    print table(Tr(\@table));
    print end_form();
    print end_html();
}



sub make_field() {
    my $table_ref;
    my $name;
    my $global_hash;
    my $hash;
    my $perm;
    ($table_ref,$name,$global_hash,$hash,$perm)=@_;

    my  $menustr;
    my  $value;

    if ($perm eq "r")
    {
	$menustr=$text{"read"};
    }
    elsif ($perm eq "w")
    {
	$menustr=$text{"write"};
    }
    elsif ($perm eq "change")
    {
	$menustr=$text{"pts_relabel"};
    }

    my $check1=0;
    my $check2=0;
    my @tmp;
    @tmp=split(/[\s\t]+/,$$hash{$perm});
    foreach(@tmp)
    {
	if ($_ eq "general")
	{
	    $check1=1;
	    next;
	}
	if ($_ eq "global")
	{
	    $check2=1;
	    next;
	}
	$value.=" ".$_;
  }

    my $global_check1=0;
    my $global_check2=0;
    my $str;
    @tmp=split(/[\s\t]+/,$$global_hash{$perm});
    foreach (@tmp)
    {
	if ($_ eq "general")
	{
	    $global_check1=1;
	    next;
	}
	if ($_ eq "global")
	{
	    $global_check2=1;
	    next;
	}
	$str.=" ".$_;
    }

    my $check1str;
    my $check2str;

    if ($global_check1==1)
    {
	$check1str=$text{"ok"};
    }
    else
    {
	$check1str=checkbox(-name=>"$name"."_general",-value=>"on",label=>"",-checked=>$check1,-onChange=>"set_change()");
    }

    if ($global_check2==1)
    {
	$check2str=$text{"ok"};
    }
    else
    {
	$check2str=checkbox(-name=>"$name"."_all",-value=>"on",label=>"",-checked=>$check2,-onChange=>"set_change()");
    }

#  delete $Domain_list{$domain};
    delete $Domain_list{"global"};
    if ($name=~/tty/)
    {
	#print $name,p;
	foreach (keys %Domain_list)
	{
	    if (!/_r$/)
	    {
		delete $Domain_list{$_};
	    }
	}
    }
    my $selectstr;
    my  @domain_array=keys %Domain_list;
    @domain_array=sort @domain_array;
    unshift @domain_array,"";

    my $msg;
    $msg=$text{"add_text_box"};
    $selectstr=$text{"choose"}.scrolling_list(-name=>"$name"."_list",-values=>\@domain_array,-size=>1,-onChange=>"select_domain(\'$name\',\'$msg\')");

    push @$table_ref,td([$menustr,$check1str,$check2str,$str.textfield(-name=>"$name"."_text",-value=>"$value"),$selectstr]);
}




sub read_tty_acl($$)
{
    my $domain;
    my $hash_ref;
    my $filename;
    ($domain,$hash_ref)=@_;

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

    #open(FILE,"<$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";


    while (<FILE>)
    {
	#    print $_,p;
	#skip spaces
	if (/[^\s\t]+.+/)
	{
	    $_=$&;
	}
	if (/^allowtty[\s\t]/)
	{
	    my @tmp;
	    my $opt;

	    @tmp= split(/[\s\t]+/,$_);
	    $opt=$tmp[1];
	    if ($opt=~/;/)
	    {
		chop($opt);
	    }

	    if ($opt eq "-create")
	    {
		$$hash_ref{"create"}=1;
		next;
	    }
	    elsif ($opt eq "-change")
	    {
		$target=$tmp[2];
		if ($target=~/;/)
		{
		    chop($target);
		}
		$$hash_ref{"change"}.=" ".$target;
	    }
	    else
	    {
		my $role;
		my $permstr;
		$role=$tmp[1];
		$permstr=$tmp[2];
		#print $role,p;
		if ($permstr=~/r/)
		{
		    $$hash_ref{"r"}.=" ".$role;
		}
		if ($permstr=~/w/)
		{
		    $$hash_ref{"w"}.=" ".$role;
		}
	    }
	}
    }

    close(FILE);
}


sub read_pts_acl($$) {
    my $domain;
    my $hash_ref;
    my $filename;
    ($domain,$hash_ref)=@_;

    if ($domain eq "global")
    {
	$filename=$Policy_root."/global";
    }
    else
    {
	$filename=$Policy_root."/$domain".".a";
    }

    #open(FILE,"<$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	#skip spaces
	if (/[^\s\t]+.+/)
	{
	    $_=$&;
	}
	if (/^allowpts[\s\t]/)
	{
	    my @tmp;
	    my $opt;

	    @tmp= split(/[\s\t]+/,$_);
	    $opt=$tmp[1];
	    if ($opt=~/;/)
	    {
		chop($opt);
	    }

	    if ($opt eq "-create")
	    {
		$$hash_ref{"create"}=1;
		next;
	    }
	    elsif ($opt eq "-change")
	    {
		my $from_domain;
		my @s;
		$from_domain=$tmp[2];
		@s=split(/[\s\t]+/,$$hash_ref{"change"});

		# not to be registared the same domain
		foreach (@s)
		{
		    if ($_ eq $from_domain)
		    {
			$from_domain="";
		    }
		}
		if ($from_domain=~/;/)
		{
		    chop($from_domain);
		}
		$$hash_ref{"change"}.=" ".$from_domain;
	    }
	    else
	    {
		my $role;
		my $permstr;
		$role=$tmp[1];
		$permstr=$tmp[2];
		if ($permstr=~/r/)
		{
		    $$hash_ref{"r"}.=" ".$role;
		}
		if ($permstr=~/w/)
		{
		    $$hash_ref{"w"}.=" ".$role;
		}
	    }
	}
    }

    close(FILE);
}
