#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: user_role.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

#Display menu to associate role with user
use Fcntl;
use CGI qw(:standard);
require 'common.pl';

$Jscript =<<"EOL";
function change_menu(user) {
    index=document.edit_form.elements["user_list"].selectedIndex;
    value=document.edit_form.elements["user_list"].options[index].text;
    location.href="user_role.cgi?user="+value;
}

function add_text(msg) {
    index=document.edit_form.elements["role_select"].selectedIndex;
    value=document.edit_form.elements["role_select"].options[index].text;
    text=document.edit_form.elements["role"].value;
    text=text+" "+value;
    document.edit_form.elements["role"].value=text;
    alert(value+" "+msg);
    set_change();
    return;
}

function check_changed(msg) {
    if (document.edit_form.elements["changed"].value ==1)
    {
	alert(msg);
    }
}

function set_change() {
    document.edit_form.elements["changed"].value=1;
}

function unset_change() {
    document.edit_form.elements["changed"].value=0;
}

EOL


local $Policy_root=set_policy_root();

#key:role name
#value:user name ,separated by space
#local %role_user;

#key:user name
#value:role name,separated by space
local %user_role;

#list of role names
local %role_list;
&read_domain_list(\%role_list,$Policy_root);
foreach (keys(%role_list))
{
    if (!/_r$/)
    {
	delete($role_list{$_});
    }
}

#list of user names
local @user_list;
#path to /etc/passwd
local $passwd_file=$config{"passwd_path"};
#user name currently shown
local $current_user=param("user");
local $default_role;

&read_user_list(\@user_list);
@user_list=sort(@user_list);
unshift @user_list,"";

&read_user_role(\%user_role);

$default_role=&read_default_role($current_user,$Policy_root);


#print CGI::header(-type=>'text/html',-charset=>'EUC_JP');
&print_header();

my $notchange=$text{"notchanged"};
print start_html(-title=>$text{"role_user"},-onUnload=>"check_changed(\'$notchange\')");

print "<SCRIPT language=\"Javascript\">";
&print_javascript();
print $Jscript;
print "</SCRIPT>";


print h2($text{"role_user"});
print a({href=>"index.cgi"},$text{"back_to_menu"});

print start_form(-method=>"post",-action=>"setuser_role.cgi",-name=>"edit_form");
print hidden(-name=>"changed",-value=>"0");


my @role_array=keys %role_list;
@role_array=sort(@role_array);
unshift @role_array,"";

print $text{"user"}.":";
print scrolling_list(-name=>"user_list",-values=>\@user_list,-size=>"1",-onchange=>"change_menu()",-default=>$current_user),p;
print $text{"allowed_role"}.":",textfield(-name=>"role",-value=>"$user_role{$current_user}",-onChange=>"set_change()");

my $msg=$text{"add_text_box"};
print $text{"add"}.":".scrolling_list(-name=>"role_select",-values=>\@role_array,-size=>"1",-onchange=>"add_text(\'$msg\')"),p;


print $text{"default_role"}.":";

my @default_role_array;
@default_role_array=split(/ /,$user_role{$current_user});
print scrolling_list(-name=>"default_role_select",-values=>\@default_role_array,-default=>"$default_role",-size=>"1",-onChange=>"set_change()"),p;

print submit(-value=>$text{"apply"},-onClick=>"unset_change()");
print end_form(),end_html();

#create Javascript from %role_user
sub print_javascript() {

    print "function change(){\n";
    print "index=document.edit_form.role.selectedIndex;\n";
    print "value=document.edit_form.role.options[index].value;\n";
    my $role;
    print "document.edit_form.user.value=\"\"\n";
    foreach $role (keys %role_list)
    {
	print "if(value==\"$role\"){\n";
	print "document.edit_form.user.value=\"$role_user{$role}\";\n";
	print "}\n";
    }

    print "}\n";
}


sub read_user_role() {
    my $hash_ref;
    $hash_ref=$_[0];

    my $role;
    foreach $role (keys(%role_list))
    {
	my $filename;
	$filename=$Policy_root."/".$role.".a";
#    open(FILE,"<$filename") or die "File open error:$filename\n";
	sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

	while (<FILE>)
	{
	    my $line=$_;

	    if ($line=~/[^\s\t]+.+/)
	    {
		$_=$&;
	    }
	    if ($line=~/^user[\s\t]/)
	    {
		my @tmp;
		my $user;
		@tmp=split(/[\s\t]+/,$line);
		$user=$tmp[1];
		if ($user=~/;/)
		{
		    chop($user);
		}
		$user_role{$user}.=" "."$role";
	    }
	}
	close(FILE);
    }
}

sub read_user_list($) {
    $hash_ref=$_[0];
    #open(FILE,"<$passwd_file") or die "File open error:$passwd_file\n";
    sysopen(FILE,"$passwd_file",O_RDONLY) or die "File open error:$passwd_file\n";

    while (<FILE>)
    {
	my @tmp;
	@tmp=split(/:/,$_);
	my $user;
	$user= $tmp[0];
	push @$hash_ref,$user;
    }

    close(FILE);
}


#read <username>_default_contexts and return default role
sub read_default_role($$) {
    my $user=$_[0];
    my $path=$_[1];
    my $default;
    my @login_domains;

    @login_domains=&get_prog_domains($path,$config{"login_path"});

    $filename=$path."/$user"."_default_contexts";
    if (!(-e $filename))
    {
	return;
    }

    #  open(FILE,"<$filename") or die "File open error:$filename\n";
    sysopen(FILE,"$filename",O_RDONLY) or die "File open error:$filename\n";

    while (<FILE>)
    {
	my $line=$_;
	if ($line=~/$login_domains[0]/)
	{
	    my @s;
	    my @s2;
	    @s=split(/[\s\t]+/,$line);
	    @s2=split(/:/,$s[1]);
	    $default=$s2[0];
	    last;
	}
    }
    close(FILE);
    return $default;

    while (<FILE>)
    {
	my $line=$_;
	#skip spaces at the head of line

	if ($line=~/[^\s\t]+.+/)
	{
	    $line=$&;
	}
	my @tmp;
	@tmp=split(/:/,$line);
	if ($tmp[0] eq $user)
	{
	    $default=$tmp[1];
	    last;
	}
	#print @tmp;
    }
    close(FILE);

    return $default;
}
