#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: view.cgi,v 1.3 2005/07/15 17:12:43 ynakam Exp $

#Edit FileACLs
use CGI qw(:standard);
require './selinux-lib.pl';

#the directory currently shown
local $current_dir;
#permission of $current_dir
local $default_perm;
#the domain currently shown
local $current_domain;

#the start position of file list in the $current_dir to show
local $start_point;
#max number of rows in one table
local $max_row;

#the number of files in $current_dir
local $file_num;

#stores the entity of table
local @table;

#If this domain is allowed to search|read|write all files;
local $search_all_flag=0;
local $read_all_flag=0;
local $write_all_flag=0;

#encoding for form
#local $encoding ="application/x-www-form-urlencoded";local 
local $enctype =&CGI::URL_ENCODED;
#local $query = new CGI;

&print_header();
#print "<meta http-equiv=\"Content-Type\" content=\"text/html; Charset=EUC-JP\">";

$current_dir=param("filepath");

if ($current_dir eq "")
{
    $current_dir="/";
}


$current_domain=param("domain");
if ($current_domain eq "")
{
    $current_domain="global";
}



if ($current_domain ne "global")
{
    &read_domain_file_acl($current_domain);
    &read_exc_file_acl($current_domain);
}

###used to show "allow exclusive"
local %File_label;#key:filename ,value:label
local %Label_file;#key:label,value:file(separated by ",")
&calc_exc_label_file(\%File_label,\%Label_file);

$start_point=param("start");
if ($start_point eq "")
{
    $start_point=1;
}

$max_row=$config{"max_row"};
if ($max_row eq "")
{
    $max_row=150;
}

my $enc_dir=&url_encode($current_dir);
my $notchange=$text{"notchanged"};


if (&check_search_all($current_domain,$Policy_root) == 1 ||
    &check_search_all("global",$Policy_root) == 1)
{
    $search_all_flag=1;
}

if (&check_adm($current_domain,$Policy_root,"read") == 1 ||
    &check_adm("global",$Policy_root,"read") == 1)
{
    $read_all_flag=1;
}

if (&check_adm($current_domain,$Policy_root,"write") == 1 ||
    &check_adm("global",$Policy_root,"write") == 1)
{
    $write_all_flag=1;
}


print start_html(-title=>$text{"file_acl"},-script=>{-src=>"file_acl.js",-language=>'JavaScript'},-onLoad=>"reflesh(\'$enc_dir\',\'$current_domain\')" ,-onUnload=>"check_changed(\'$notchange\')");


print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";


if ($current_dir eq "Root")
{
    $current_dir="/";
    &print_root();
}
else
{
    #count $file_num
    $file_num=0;
    opendir(DIR,"$current_dir") or die "could not open $current_dir\n";
    while ($_=readdir(DIR))
    {
	if ($_ eq "."||$_ eq "..")
	{
	    next;
	}
	$file_num++;
    }
    close(DIR);

    $default_perm=&calc_default_perm($current_dir,$current_domain);
    print_dir_list($current_dir);
}

print end_html();


#the menu for "Root" directory
sub print_root() {
    my $perm;
    print $text{"file_acl_root_menu"},":$current_domain",br;

#start_form can not display    "application/x-www-form-urlencoded"...
#    print start_form(-method=>"post",-action=>"set_file_acl.cgi",-name=>"edit_form");
    print "<form method=\"post\" action=\"set_file_acl.cgi\"  name=\"edit_form\" enctype=\"$enctype\">";

    print hidden(-name=>"Root",-value=>"current");
    print hidden(-name=>$current_domain,-value=>"domain");

    &print_head_row();

    &print_row("/","");

    push @table,td([submit(-value=>$text{"apply"})]);
    print table(Tr(\@table));
    print end_form();
}


sub print_page_changer() {
    my $back=$start_point-$max_row;

    if ($back>0)
    {
	print a({-href=>"view.cgi?filepath=$enc_dir&domain=$current_domain&start=$back",-target=>"frame2"},"<<<");
    }

    my $i;

    for ($i=1;$i<=$file_num;$i+=$max_row)
    {
	my $class;
	if ($i==$start_point)
	{
	    $class="red";
	}
	else
	{
	    $class="blue";
	}
	print a({-href=>"view.cgi?filepath=$enc_dir&domain=$current_domain&start=$i",-target=>"frame2",-class=>$class},"$i"."-");
	print "   ";
    }
    my $forward=$start_point+$max_row;
    if ($forward<$file_num)
    {
	print a({-href=>"view.cgi?filepath=$enc_dir&domain=$current_domain&start=$forward",-target=>"frame2"},">>>");
    }
}

#
#print_dir_list(dirname)
sub print_dir_list() {
    my $dir;
    my $fullpath;

    my $i;
    $dir=$_[0];
    print $text{"current_domain"}." :$current_domain :";
    print $text{"current_dir"}." :$dir";
    print $text{"file_number"}." :$file_num",br;


    opendir(DIR,"$dir") or die "could not open $dir\n";

    #store filenames in $current_dir
    my @dirs;
    $i=0;
    while ($_=readdir(DIR))
    {
	if ($_ eq "."||$_ eq "..")
	{
	    next;
	}

	if ($dir eq "/")
	{
	    $fullpath=$dir.$_;
	}
	else
	{
	    $fullpath=$dir."/".$_;
	}

	$dirs[$i]=$_;
	$i++;
    }
        
    
#start_form can not display    "application/x-www-form-urlencoded"...
#    print start_form(-method=>"post",-action=>"set_file_acl.cgi",-name=>"edit_form");
    print "<form method=\"post\" action=\"set_file_acl.cgi\"  name=\"edit_form\" enctype=\"$enctype\">";
    #for set_file_acl.cgi
    print hidden(-name=>"$current_dir",-value=>"current");
    print hidden(-name=>$current_domain,-value=>"domain");
    print hidden(-name=>"start",-value=>"$start_point");
    print hidden(-name=>"changed",-value=>"0");

    &print_page_changer();

    print hr;

    print_head_row();
    print_second_row();


    my @tmp=sort @dirs;
    @dirs=@tmp;

    my $start=$start_point;
    my $i=0;
    my $range=$max_row;
    my $end=$start+$range-1;

    foreach (@dirs)
    {
	$i++;
	if ($i<$start)
	{
	    next;
	}
	if ($i>$end)
	{
	    last;
	}

	if ($dir eq "/")
	{
	    $fullpath=$dir.$_;
	}
	else
	{
	    $fullpath=$dir."/".$_;
	}
	print_row($fullpath,$_);
    }

    #
    my $row;
    $row=["r","w","x","s","",""," "];
    if ($current_domain eq "global")
    {
	unshift @$row,"deny";
    }
    unshift @$row," ";
    push @table,th({-bgcolor=>"yellow"},$row);

    #show allow exclusive
    local $c_count=0;		#number of checked boxs of "c"
    if ($current_domain ne "global")
    {
	print_exc_list();
    }


#    push @table,td([submit(-value=>$text{"apply"},-onClick=>"unset_change()")]);

#     if($current_domain ne "global"){
#       push @table,td([button(-value=>$text{"exclusive_file"},-onClick=>"open_editor(\'#000000\',\'300\',\'200\',\'$current_domain\',\'$current_dir\',null,null  );")]);
#     }

    print table(Tr(\@table));

    print p,td([submit(-value=>$text{"apply"},-onClick=>"unset_change()")]);

    if ($current_domain ne "global")
    {
	my $menu;
	if ($c_count==0)
	{
	    $menu=&text("exc_edit_name",$current_domain,$current_dir);
	    print p,td([button(-value=>$text{"exclusive_file"},-onClick=>"open_editor(\'#000000\',\'400\',\'200\',\'$current_domain\',\'$current_dir\',null,\'$menu\'  );")]);
	}
	else
	{
	    $menu=&text("exc_edit_name",$current_domain,$current_dir);
	    my $alert=$text{"alert_multiple_c"};
	    print p,td([button(-value=>$text{"exclusive_file"},-onClick=>"alert(\'$alert\')")]);
	}
    }

    print hr;

    &print_page_changer();
    end_form();
    closedir(DIR);
}

#show first row of the table
sub print_head_row() {
    print button(-value=>$text{"file_acl_all"},-onClick=>"open_config_view(\'#000000\',\'600\',\'300\',\'$current_domain\');");
    print hr;

    my $row;
    $row=["r","w","x","s","allow-only","allow-recursive"," "];
    $row=["r","w","x","s"];
    $row2=[$text{"inherit_child"}," "];

    if ($current_domain eq "global")
    {
	unshift @$row,"deny";
    }
    unshift @$row," ";
    my  $t;
    $t=th({-bgcolor=>"yellow",-align=>"center"},$row).th({-colspan=>"2",-bgcolor=>"yellow",-align=>"center"},$row2);
#  push @table,th({-bgcolor=>"yellow",-align=>"center"},$row);
    push @table,$t;
}

sub print_second_row() {
    my @row;

    push @row,$text{"default"}."\n";


    &print_permission($current_dir,$default_perm,\@row);

 #    if ($current_domain eq "global")
#     {
# 	push @row," ";
#     }

#     if (($default_perm & $READ)!=0)
#     {
# 	push @row,$text{"ok"};
#     }
#     else
#     {
# 	push @row,"-";
#     }

#     if (($default_perm & $WRITE)!=0)
#     {
# 	push @row,$text{"ok"};
#     }
#     else
#     {
# 	push @row,"-";
#     }

#     if (($default_perm & $EXECUTE)!=0)
#     {
# 	push @row,$text{"ok"};
#     }
#     else
#     {
# 	push @row,"-";
#     }

#     if (($default_perm & $SEARCH)!=0)
#     {
# 	push @row,$text{"ok"};
#     }
#     else
#     {
# 	push @row,"-";
#     }

#     my $onlyflag;

#     my @row2;

#     $onlyflag=&calc_allowonly(".",$current_domain);
#     if ($onlyflag==1)
#     {
# 	#      push @row,$text{"ok"};
# 	#     push @row ,"-";
# 	push @row2,"no";
# 	push @row2,"";
# 	print "<INPUT TYPE=hidden NAME=\"$current_dir\" VALUE=only>";
#     }
#     else
#     {
# 	push @row2,"yes";
# 	push @row2,"";
# 	#      push @row ,"-";
# 	#     push @row,$text{"ok"};
# 	print "<INPUT TYPE=hidden NAME=\"$current_dir\" VALUE=all>";
#     }

#     push @row2 ," ";
#     my $all_td;
    &print_allowonly(".",$current_domain,\@row);

    $all_td=td({-align=>"center"},\@row).td({-align=>"center",-colspan=>"2"},\@row2);

#    push @table,td({-align=>"center"},\@row);
    push @table,$all_td;

}

#print one row
#fullpath
#name
sub print_row($$) {
    my $fullpath;
    my $name;
    my $perm;
    my @row;#the element of row
    ($fullpath,$name)=@_;

    $name=&escape_tag($name);

    if (exists($File_label{$name}))
    {					#You shouldn't configure the file labeled by file_type_trans
	push @row,"$name";
	push @table,td({-align=>"left"},\@row);
	return;
    }

    #to implement page changer
    #tell set_file_acl.cgi which file to configure
    my $hiddenname="name_"."$fullpath";
    print hidden(-name=>$hiddenname,-value=>1);

    if ( -d $fullpath)
    {
	#color file/directory
	my $class="blue";
	if (exists($Global_Explicit{$fullpath}))
	{
	    $class="red";
	}
	if (exists($Explicit{$fullpath}))
	{
	    $class="green";
	}
	if (exists($Explicit{$fullpath})&& exists($Global_Explicit{$fullpath}))
	{
	    $class="yellow";
	}

	my $enc_path;
	$enc_path=&url_encode($fullpath);
	push @row,"<a href =$scriptname?filepath=$enc_path&domain=$current_domain target=\"frame2\" class=$class>". "$name"."</a>\n";
    }
    else
    {
	my $class="black";
	if (exists($Global_Explicit{$fullpath}))
	{
	    $class="red";
	}
	if (exists($Explicit{$fullpath}))
	{
	    $class="green";
	}

	push @row,"<div style=\"color:$class\">$name</div>\n";
    }

    $perm=calc_perm($fullpath,$current_domain);
    print_permission($fullpath,$perm,\@row);
    if ( -d $fullpath)
    {
	print_allowonly($name,$current_domain,\@row);
    }
    else
    {
	push @row," ";
	push @row," ";
    }
    push @row,button(-label=>$text{"property"},-onClick=>"open_file2_perm_view(\'$fullpath\')");
#    push @row,a({-href=>"Javascript:onClick=open_file2_perm_view(\'$fullpath\')"},"ץѥƥ");

    push @table,td({-align=>"left"},\@row);
}


sub print_hidden_row($$) {
    my $dir;
    my $name;
    my $perm;

    ($dir,$name)=@_;
    $perm=calc_perm($dir,$current_domain);

    #show explicit deny checkbox in global domain
    if ($current_domain eq "global")
    {
	my $flag=0;

	if (exists($Global_allow{$dir})||exists($Global_allowonly{$dir}))
	{
	    if ($perm == $DENY)
	    {
		$flag=1;
	    }
	}
	if ($flag==1)
	{
	    print hidden(-name=>"deny_$dir",-value=>"deny");
	}
    }

    #r
    if (($perm & $READ)!=0)
    {
	print hidden(-name=>"r_$dir",-value=>"r");
    }
    #w
    if (($perm & $WRITE)!=0)
    {
	print hidden(-name=>"w_$dir",-value=>"w");
    }

    #x
    if (($perm & $EXECUTE)!=0)
    {
	print hidden(-name=>"x_$dir",-value=>"x");
    }

    #s
    if (($perm & $SEARCH)!=0)
    {
	print hidden(-name=>"s_$dir",-value=>"s");
    }

    #information about allowonly is in hidden tag.
    if ( -d $dir)
    {
	my $onlyflag;
	$onlyflag=&calc_allowonly($name,$current_domain);
	if ($onlyflag==1)
	{
	    print hidden(-name=>"only_$dir",-value=>"only");
	}
	else
	{
	    print hidden(-name=>"all_$dir",-value=>"all");
	}
    }
}

#dir:fullpath of file(!)
#perm:permission
#using these,display checkboxes
sub print_permission($$$) {
    my $perm;
    my $dir;
    my $rowref;
    ($dir,$perm,$rowref)=@_;

    #explicit deny for global
    if ($current_domain eq "global")
    {
	my $flag=0;

	if (exists($Global_allow{$dir})||exists($Global_allowonly{$dir}))
	{
	    if ($perm == $DENY)
	    {
		$flag=1;
	    }
	}
	push @$rowref,checkbox(-name=>"deny_$dir",-value=>"deny",-label=>"",-checked=>$flag,-onChange=>"set_change()");
    }

    #r
    if ($read_all_flag==0)
    {
	if (($perm & $READ)!=0)
	{
	    push @$rowref,checkbox(-name=>"r_$dir",-value=>"r",-label=>"",-checked=>1,-onChange=>"set_change()");
	}
	else
	{
	    push @$rowref,checkbox(-name=>"r_$dir",-value=>"r",-label=>"",-checked=>0,-onChange=>"set_change()");
	}
    }
    else
    {
	if (($perm &$READ)!=0)
	{
	    push @$rowref,$text{"ok"}.hidden(-name=>r_$dir,-value=>"r");
	}
	else
	{
	    push @$rowref,$text{"ok"};
	}
    }

    #w
    if ($write_all_flag==0)
    {
	if (($perm & $WRITE)!=0)
	{
	    push @$rowref,checkbox(-name=>"w_$dir",-value=>"w",-label=>"",-checked=>1,-onChange=>"set_change()");
	}
	else
	{
	    push @$rowref,checkbox(-name=>"w_$dir",-value=>"w",-label=>"",-checked=>0,-onChange=>"set_change()");
	}
    }
    else
    {
	if (($perm &$WRITE)!=0)
	{
	    push @$rowref,$text{"ok"}.hidden(-name=>"w_$dir",-value=>"w");
	}
	else
	{
	    push @$rowref,$text{"ok"};
	}
    }
    #x
    if (($perm & $EXECUTE)!=0)
    {
	push @$rowref,checkbox(-name=>"x_$dir",-value=>"x",-label=>"",-checked=>1,-onChange=>"set_change()");
    }
    else
    {
	push @$rowref,checkbox(-name=>"x_$dir",-value=>"x",-label=>"",-checked=>0,-onChange=>"set_change()");
    }

    #s
    if ($search_all_flag==0)
    {
      my $checked;
      if (($perm & $SEARCH)!=0)
      {
	  $checked=1;
      }
      else
      {
	  $checked=0;
      }
      push @$rowref,checkbox(-name=>"s_$dir",-value=>"s",-label=>"",-checked=>$checked,-onChange=>"set_change()");
    }
    else
    {
	# allowadm relabel is set
	if (($perm &$SEARCH)!=0)
	{
	    push @$rowref,$text{"ok"}.hidden(-name=>"s_$dir",-value=>"s");
	}
	else
	{
	    push @$rowref,$text{"ok"};
	}
    }
}

#$name
#$domain
#check whether $name is allowonlyname
#if allowonly, return 1
sub calc_allowonly($$) {
    my $fullpath;
    my $name;
    my $domain;
    my $perm;
    my $onlyflag=0;
    ($name,$domain)=@_;

    if ($name eq ".")
    {
	$fullpath=$current_dir;
    }
    else
    {
	if ($current_dir eq "/")
	{
	    $fullpath=$current_dir.$name;
	}
	else
	{
	    $fullpath=$current_dir."/".$name;
	}
    }

    if ($domain eq "global")
    {
	if (exists($Global_allowonly{$fullpath}) )
	{
	    $onlyflag=1;
	}
    }
    else
    {
	if (exists($Domain_allowonly{$fullpath}))
	{
	    $onlyflag=1;
	}
	else
	{
	    if (!exists($Domain_allow{$fullpath}))
	    {
		if (exists($Global_allowonly{$fullpath}))
		{
		    $onlyflag=1;
		}
	    }
	}
    }

    return $onlyflag;
}

#$name
#$domain
#Display radio box to show whether $name is allow or allowonly.
sub print_allowonly($$$) {
    my $fullpath;
    my $name;
    my $domain;
    my $rowref;
    my $perm;
    my $onlyflag=0;
    ($name,$domain,$rowref)=@_;

    if ($name eq ".")
    {
	$fullpath=$current_dir;
    }
    else
    {
	if ($current_dir eq "/")
	{
	    $fullpath=$current_dir.$name;
	}
	else
	{
	    $fullpath=$current_dir."/".$name;
	}
    }
    $onlyflag=&calc_allowonly($name,$domain);

    if ($onlyflag==0)
    {

	push @$rowref,radio_group(-name=>"radio_all_$fullpath",-values=>["all","only"],-labels=>{"all"=>"yes","only"=>"no"},-default=>"all",-onChange=>"set_change()");

    }
    elsif ($onlyflag==1)
    {				#allowonly

	push @$rowref,radio_group(-name=>"radio_only_$fullpath",-values=>["all","only"],-labels=>{"all"=>"yes","only"=>"no"},-default=>"only",-onChange=>"set_change()");
    }
}


#Display "allow exclusive"
sub print_exc_list() {
    my $tmp;
    my @names;

    if (!exists($Exc_dir{$current_dir}))
    {
	return;
    }
    push @table,th({-align=>"center",-bgcolor=>"yellow"},[$text{"file_type_trans"},"r\n","w\n","x\n","s\n","c"]);

    $tmp=$Exc_dir{$current_dir};

    @names=split(/,/,$tmp);
    #print "@names<br>";
    foreach (@names)
    {
	my @row;
	my $perm;
	$perm=$Exc_allow{$_};
	if ($perm eq "")
	{
	    $perm=$DENY;
	}

	# my $menu;
	#  $menu=$text{"exc_change"};
	#   push @row,"<a href=\"Javascript:onClick=open_editor(\'#000000\',\'400\',\'200\',\'$current_domain\',\'$current_dir\',\'$_\',\'$menu\')\" CLASS=red >$_</A>\n";

	push @row,"<div style=\"color:red\">$_</div>";
	print_permission($_,$perm,\@row);

	if (($perm & $EXC_CREATE)!=0)
	{
	    push @row,checkbox(-name=>"c_$_",-label=>"",-value=>"c",-checked=>1);
	    $c_count++;
	}
	else
	{
	    push @row,checkbox(-name=>"c_$_",-label=>"",-value=>"c",-checked=>0);
	}
	push @row,"";
	push @row,button(-label=>$text{"property"},-onClick=>"open_exc2_perm_view(\'$_\',\'$current_dir\')");

	push @table,td(\@row);

	if (!exists($Label_file{$_}))
	{
	    next;
	}

	#print file list associated with label
	my @files;
	@files=split(/,/,$Label_file{$_});
	@files=sort(@files);
	my $name;
	foreach $name (@files)
	{
	    my @file_row;
	    push @file_row,$name;
	    push @table,td({-align=>"left"},\@file_row);
	}
    }
}


#calculate assosiation of file with label(allow exclusive label)
#arg 1:reference of hash,key:filename,value:label
#arg 2:reference of hash,key:label,value:filename(separated by ",")
#and set these hashtable.
sub calc_exc_label_file() {
    my $file_label_hash_ref;
    my $label_file_hash_ref;

    ($file_label_hash_ref,$label_file_hash_ref)=@_;

    my $selinux_bin=$config{"selinux_bin"};
    if (!exists($config{"selinux_bin"}))
    {
	$selinux_bin="/usr/local/selinux/bin";
    }

    my $out;
    $out=`$selinux_bin/ls -a --context $current_dir;`;
    if ($out eq "")
    {
	return;
    }

    my @exc_names;
    @exc_names=split(/,/,$Exc_dir{$current_dir});
    my %exc_hash;
    foreach (@exc_names)
    {
	$exc_hash{$_}=1;
    }

    my @tmp;
    @tmp=split(/\n/,$out);
    foreach (@tmp)
    {
	my @tmp2;
	my @tmp3;
	my $context;
	my $type;
	my $file;
	@tmp2=split(/[\s\t]+/,$_);
	$context=$tmp2[3];
	$file=$tmp2[4];
	@tmp3=split(/:/,$context);
	$type=$tmp3[2];
	if (exists($exc_hash{$type}))
	{
	    #print "$file:$type",p;
	    $$file_label_hash_ref{$file}=$type;
	    if (!exists($$label_file_hash_ref{$type}))
	    {
		$$label_file_hash_ref{$type}=$file;
	    }
	    else
	    {
		$$label_file_hash_ref{$type}.=","."$file";
	    }
	}
    }
}
